/* Generated automatically by the program `genrecog' from the target
   machine description file.  */

#include "config.h"
#include "system.h"
#include "coretypes.h"
#include "backend.h"
#include "predict.h"
#include "rtl.h"
#include "memmodel.h"
#include "tm_p.h"
#include "emit-rtl.h"
#include "insn-config.h"
#include "recog.h"
#include "output.h"
#include "flags.h"
#include "df.h"
#include "resource.h"
#include "diagnostic-core.h"
#include "reload.h"
#include "regs.h"
#include "tm-constrs.h"



/* `recog' contains a decision tree that recognizes whether the rtx
   X0 is a valid instruction.

   recog returns -1 if the rtx is not valid.  If the rtx is valid, recog
   returns a nonnegative number which is the insn code number for the
   pattern that matched.  This is the same as the order in the machine
   description of the entry that matched.  This number can be used as an
   index into `insn_data' and other tables.

   The third parameter to recog is an optional pointer to an int.  If
   present, recog will accept a pattern if it matches except for missing
   CLOBBER expressions at the end.  In that case, the value pointed to by
   the optional pointer will be set to the number of CLOBBERs that need
   to be added (it should be initialized to zero by the caller).  If it
   is set nonzero, the caller should allocate a PARALLEL of the
   appropriate size, copy the initial entries, and call add_clobbers
   (found in insn-emit.c) to fill in the CLOBBERs.


   The function split_insns returns 0 if the rtl could not
   be split or the split rtl as an INSN list if it can be.

   The function peephole2_insns returns 0 if the rtl could not
   be matched. If there was a match, the new rtl is returned in an INSN list,
   and LAST_INSN will point to the last recognized insn in the old sequence.
*/






static int
pattern0 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!nvptx_register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !nvptx_register_operand (operands[1], i1)
      || !nvptx_nonmemory_operand (operands[2], i1))
    return -1;
  return 0;
}

static int
pattern1 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  x5 = XEXP (x3, 1);
  operands[2] = x5;
  switch (GET_MODE (operands[0]))
    {
    case HImode:
      return pattern0 (x3, HImode); /* [-1, 0] */

    case SImode:
      if (pattern0 (x3, SImode) != 0)
        return -1;
      return 1;

    case DImode:
      if (pattern0 (x3, DImode) != 0)
        return -1;
      return 2;

    default:
      return -1;
    }
}

static int
pattern2 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  switch (GET_MODE (operands[0]))
    {
    case HImode:
      if (!nvptx_register_operand (operands[0], HImode)
          || GET_MODE (x3) != HImode
          || !nvptx_register_operand (operands[1], HImode))
        return -1;
      return 0;

    case SImode:
      if (!nvptx_register_operand (operands[0], SImode)
          || GET_MODE (x3) != SImode
          || !nvptx_register_operand (operands[1], SImode))
        return -1;
      return 1;

    case DImode:
      if (!nvptx_register_operand (operands[0], DImode)
          || GET_MODE (x3) != DImode
          || !nvptx_register_operand (operands[1], DImode))
        return -1;
      return 2;

    case SFmode:
      if (!nvptx_register_operand (operands[0], SFmode)
          || GET_MODE (x3) != SFmode
          || !nvptx_register_operand (operands[1], SFmode))
        return -1;
      return 3;

    case DFmode:
      if (!nvptx_register_operand (operands[0], DFmode)
          || GET_MODE (x3) != DFmode
          || !nvptx_register_operand (operands[1], DFmode))
        return -1;
      return 4;

    default:
      return -1;
    }
}

static int
pattern3 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  x5 = XEXP (x3, 1);
  operands[2] = x5;
  if (!nvptx_nonmemory_operand (operands[2], SImode))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case SImode:
      if (!nvptx_register_operand (operands[0], SImode)
          || GET_MODE (x3) != SImode
          || !nvptx_register_operand (operands[1], SImode))
        return -1;
      return 0;

    case DImode:
      if (!nvptx_register_operand (operands[0], DImode)
          || GET_MODE (x3) != DImode
          || !nvptx_register_operand (operands[1], DImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

static int
pattern4 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  x5 = XEXP (x3, 1);
  operands[2] = x5;
  switch (GET_MODE (operands[0]))
    {
    case BImode:
      return pattern0 (x3, BImode); /* [-1, 0] */

    case HImode:
      if (pattern0 (x3, HImode) != 0)
        return -1;
      return 1;

    case SImode:
      if (pattern0 (x3, SImode) != 0)
        return -1;
      return 2;

    case DImode:
      if (pattern0 (x3, DImode) != 0)
        return -1;
      return 3;

    default:
      return -1;
    }
}

static int
pattern5 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (GET_MODE (x1) != i1)
    return -1;
  switch (GET_MODE (operands[1]))
    {
    case SImode:
      if (!nvptx_register_operand (operands[1], SImode))
        return -1;
      return 0;

    case DImode:
      if (!nvptx_register_operand (operands[1], DImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

static int
pattern6 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  switch (GET_MODE (operands[0]))
    {
    case SFmode:
      if (!nvptx_register_operand (operands[0], SFmode))
        return -1;
      return pattern5 (x3, SFmode); /* [-1, 1] */

    case DFmode:
      if (!nvptx_register_operand (operands[0], DFmode))
        return -1;
      res = pattern5 (x3, DFmode);
      if (res >= 0)
        return res + 2; /* [2, 3] */
      return -1;

    default:
      return -1;
    }
}

static int
pattern7 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!nvptx_register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  switch (GET_MODE (operands[1]))
    {
    case SFmode:
      if (!nvptx_register_operand (operands[1], SFmode))
        return -1;
      return 0;

    case DFmode:
      if (!nvptx_register_operand (operands[1], DFmode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

static int
pattern8 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  switch (GET_MODE (operands[0]))
    {
    case SImode:
      return pattern7 (x3, SImode); /* [-1, 1] */

    case DImode:
      res = pattern7 (x3, DImode);
      if (res >= 0)
        return res + 2; /* [2, 3] */
      return -1;

    default:
      return -1;
    }
}

static int
pattern9 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[1] = x2;
  x3 = XEXP (x1, 1);
  operands[2] = x3;
  switch (GET_MODE (operands[0]))
    {
    case HImode:
      return pattern0 (x1, HImode); /* [-1, 0] */

    case SImode:
      if (pattern0 (x1, SImode) != 0)
        return -1;
      return 1;

    case DImode:
      if (pattern0 (x1, DImode) != 0)
        return -1;
      return 2;

    case SFmode:
      if (pattern0 (x1, SFmode) != 0)
        return -1;
      return 3;

    case DFmode:
      if (pattern0 (x1, DFmode) != 0)
        return -1;
      return 4;

    default:
      return -1;
    }
}

static int
pattern10 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!nvptx_register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !nvptx_nonmemory_operand (operands[2], i1)
      || !nvptx_nonmemory_operand (operands[3], i1))
    return -1;
  return 0;
}

static int
pattern11 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 1);
  if (x4 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x5 = XEXP (x3, 0);
  switch (GET_CODE (x5))
    {
    case REG:
      if (!nvptx_register_operand (x5, BImode))
        return -1;
      x6 = XEXP (x2, 1);
      switch (GET_CODE (x6))
        {
        case LABEL_REF:
          x7 = XEXP (x2, 2);
          if (GET_CODE (x7) != PC)
            return -1;
          x8 = XEXP (x1, 0);
          if (GET_CODE (x8) != PC)
            return -1;
          operands[0] = x5;
          x9 = XEXP (x6, 0);
          operands[1] = x9;
          return 0;

        case CONST_INT:
        case CONST_DOUBLE:
        case REG:
          operands[2] = x6;
          x8 = XEXP (x1, 0);
          operands[0] = x8;
          operands[1] = x5;
          x7 = XEXP (x2, 2);
          operands[3] = x7;
          switch (GET_MODE (operands[0]))
            {
            case HImode:
              if (pattern10 (x2, HImode) != 0)
                return -1;
              return 1;

            case SImode:
              if (pattern10 (x2, SImode) != 0)
                return -1;
              return 2;

            case DImode:
              if (pattern10 (x2, DImode) != 0)
                return -1;
              return 3;

            case SFmode:
              if (pattern10 (x2, SFmode) != 0)
                return -1;
              return 4;

            case DFmode:
              if (pattern10 (x2, DFmode) != 0)
                return -1;
              return 5;

            default:
              return -1;
            }

        default:
          return -1;
        }

    case UNSPEC:
      if (XVECLEN (x5, 0) != 1
          || XINT (x5, 1) != 18
          || GET_MODE (x5) != BImode)
        return -1;
      x6 = XEXP (x2, 1);
      if (GET_CODE (x6) != LABEL_REF)
        return -1;
      x7 = XEXP (x2, 2);
      if (GET_CODE (x7) != PC)
        return -1;
      x8 = XEXP (x1, 0);
      if (GET_CODE (x8) != PC)
        return -1;
      x10 = XVECEXP (x5, 0, 0);
      operands[0] = x10;
      if (!nvptx_register_operand (operands[0], BImode))
        return -1;
      x9 = XEXP (x6, 0);
      operands[1] = x9;
      return 6;

    default:
      return -1;
    }
}

static int
pattern12 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!nvptx_register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  switch (GET_MODE (operands[1]))
    {
    case SFmode:
      if (!nvptx_register_operand (operands[1], SFmode))
        return -1;
      return 0;

    case DFmode:
      if (!nvptx_register_operand (operands[1], DFmode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

static int
pattern13 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  operands[1] = x2;
  switch (GET_MODE (operands[0]))
    {
    case SFmode:
      if (!nvptx_register_operand (operands[0], SFmode)
          || GET_MODE (x1) != SFmode
          || !nvptx_register_operand (operands[1], SFmode))
        return -1;
      return 0;

    case DFmode:
      if (!nvptx_register_operand (operands[0], DFmode)
          || GET_MODE (x1) != DFmode
          || !nvptx_register_operand (operands[1], DFmode))
        return -1;
      return 1;

    case SImode:
      res = pattern12 (x1, SImode);
      if (res >= 0)
        return res + 2; /* [2, 3] */
      return -1;

    case DImode:
      res = pattern12 (x1, DImode);
      if (res >= 0)
        return res + 4; /* [4, 5] */
      return -1;

    default:
      return -1;
    }
}

static int
pattern14 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  operands[1] = x2;
  switch (GET_MODE (operands[0]))
    {
    case SFmode:
      if (!nvptx_register_operand (operands[0], SFmode)
          || GET_MODE (x1) != SFmode
          || !nvptx_register_operand (operands[1], SFmode))
        return -1;
      return 0;

    case DFmode:
      if (!nvptx_register_operand (operands[0], DFmode)
          || GET_MODE (x1) != DFmode
          || !nvptx_register_operand (operands[1], DFmode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

static int
pattern15 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!nvptx_register_operand (operands[0], SImode)
      || GET_MODE (x1) != SImode)
    return -1;
  switch (GET_MODE (operands[1]))
    {
    case QImode:
      if (!nvptx_nonimmediate_operand (operands[1], QImode))
        return -1;
      return 0;

    case HImode:
      if (!nvptx_nonimmediate_operand (operands[1], HImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

static int
pattern16 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!nvptx_register_operand (operands[0], DImode)
      || GET_MODE (x1) != DImode)
    return -1;
  switch (GET_MODE (operands[1]))
    {
    case QImode:
      if (!nvptx_nonimmediate_operand (operands[1], QImode))
        return -1;
      return 0;

    case HImode:
      if (!nvptx_nonimmediate_operand (operands[1], HImode))
        return -1;
      return 1;

    case SImode:
      if (!nvptx_nonimmediate_operand (operands[1], SImode))
        return -1;
      return 2;

    default:
      return -1;
    }
}

static int
pattern17 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!nvptx_register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !nvptx_register_operand (operands[1], i1)
      || !nvptx_register_operand (operands[2], i1))
    return -1;
  return 0;
}

static int
pattern18 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!nvptx_register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !nvptx_register_operand (operands[1], i1)
      || !nvptx_nonmemory_operand (operands[2], i1))
    return -1;
  return 0;
}

static int
pattern19 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  operands[2] = x2;
  switch (GET_MODE (operands[0]))
    {
    case HImode:
      return pattern18 (x1, HImode); /* [-1, 0] */

    case SImode:
      if (pattern18 (x1, SImode) != 0)
        return -1;
      return 1;

    case DImode:
      if (pattern18 (x1, DImode) != 0)
        return -1;
      return 2;

    case SFmode:
      if (pattern18 (x1, SFmode) != 0)
        return -1;
      return 3;

    case DFmode:
      if (pattern18 (x1, DFmode) != 0)
        return -1;
      return 4;

    default:
      return -1;
    }
}

static int
pattern20 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[3] = x2;
  x3 = XEXP (x2, 0);
  operands[4] = x3;
  x4 = XEXP (x2, 1);
  operands[5] = x4;
  x5 = XEXP (x1, 1);
  x6 = XEXP (x5, 0);
  operands[0] = x6;
  x7 = XEXP (x5, 1);
  x8 = XEXP (x7, 0);
  operands[1] = x8;
  return pattern19 (x7); /* [-1, 4] */
}

static int
pattern21 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[3] = x2;
  x3 = XEXP (x2, 0);
  operands[4] = x3;
  x4 = XEXP (x2, 1);
  operands[5] = x4;
  x5 = XEXP (x1, 1);
  x6 = XEXP (x5, 0);
  operands[0] = x6;
  x7 = XEXP (x5, 1);
  x8 = XEXP (x7, 0);
  operands[1] = x8;
  x9 = XEXP (x7, 1);
  operands[2] = x9;
  switch (GET_MODE (operands[0]))
    {
    case HImode:
      return pattern18 (x7, HImode); /* [-1, 0] */

    case SImode:
      if (pattern18 (x7, SImode) != 0)
        return -1;
      return 1;

    case DImode:
      if (pattern18 (x7, DImode) != 0)
        return -1;
      return 2;

    default:
      return -1;
    }
}

static int
pattern22 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[2] = x2;
  x3 = XEXP (x2, 0);
  operands[3] = x3;
  x4 = XEXP (x2, 1);
  operands[4] = x4;
  x5 = XEXP (x1, 1);
  x6 = XEXP (x5, 0);
  operands[0] = x6;
  x7 = XEXP (x5, 1);
  x8 = XEXP (x7, 0);
  operands[1] = x8;
  switch (GET_MODE (operands[0]))
    {
    case HImode:
      if (!nvptx_register_operand (operands[0], HImode)
          || GET_MODE (x7) != HImode
          || !nvptx_register_operand (operands[1], HImode))
        return -1;
      return 0;

    case SImode:
      if (!nvptx_register_operand (operands[0], SImode)
          || GET_MODE (x7) != SImode
          || !nvptx_register_operand (operands[1], SImode))
        return -1;
      return 1;

    case DImode:
      if (!nvptx_register_operand (operands[0], DImode)
          || GET_MODE (x7) != DImode
          || !nvptx_register_operand (operands[1], DImode))
        return -1;
      return 2;

    case SFmode:
      if (!nvptx_register_operand (operands[0], SFmode)
          || GET_MODE (x7) != SFmode
          || !nvptx_register_operand (operands[1], SFmode))
        return -1;
      return 3;

    case DFmode:
      if (!nvptx_register_operand (operands[0], DFmode)
          || GET_MODE (x7) != DFmode
          || !nvptx_register_operand (operands[1], DFmode))
        return -1;
      return 4;

    default:
      return -1;
    }
}

static int
pattern23 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[3] = x2;
  x3 = XEXP (x2, 0);
  operands[4] = x3;
  x4 = XEXP (x2, 1);
  operands[5] = x4;
  x5 = XEXP (x1, 1);
  x6 = XEXP (x5, 0);
  operands[0] = x6;
  x7 = XEXP (x5, 1);
  x8 = XEXP (x7, 0);
  operands[1] = x8;
  x9 = XEXP (x7, 1);
  operands[2] = x9;
  if (!nvptx_nonmemory_operand (operands[2], SImode))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case SImode:
      if (!nvptx_register_operand (operands[0], SImode)
          || GET_MODE (x7) != SImode
          || !nvptx_register_operand (operands[1], SImode))
        return -1;
      return 0;

    case DImode:
      if (!nvptx_register_operand (operands[0], DImode)
          || GET_MODE (x7) != DImode
          || !nvptx_register_operand (operands[1], DImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

static int
pattern24 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[3] = x2;
  x3 = XEXP (x2, 0);
  operands[4] = x3;
  x4 = XEXP (x2, 1);
  operands[5] = x4;
  x5 = XEXP (x1, 1);
  x6 = XEXP (x5, 0);
  operands[0] = x6;
  x7 = XEXP (x5, 1);
  x8 = XEXP (x7, 0);
  operands[1] = x8;
  x9 = XEXP (x7, 1);
  operands[2] = x9;
  switch (GET_MODE (operands[0]))
    {
    case BImode:
      return pattern18 (x7, BImode); /* [-1, 0] */

    case HImode:
      if (pattern18 (x7, HImode) != 0)
        return -1;
      return 1;

    case SImode:
      if (pattern18 (x7, SImode) != 0)
        return -1;
      return 2;

    case DImode:
      if (pattern18 (x7, DImode) != 0)
        return -1;
      return 3;

    default:
      return -1;
    }
}

static int
pattern25 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (GET_MODE (x1) != i1)
    return -1;
  switch (GET_MODE (operands[1]))
    {
    case SImode:
      if (!nvptx_register_operand (operands[1], SImode))
        return -1;
      return 0;

    case DImode:
      if (!nvptx_register_operand (operands[1], DImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

static int
pattern26 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[2] = x2;
  x3 = XEXP (x2, 0);
  operands[3] = x3;
  x4 = XEXP (x2, 1);
  operands[4] = x4;
  x5 = XEXP (x1, 1);
  x6 = XEXP (x5, 0);
  operands[0] = x6;
  x7 = XEXP (x5, 1);
  x8 = XEXP (x7, 0);
  operands[1] = x8;
  switch (GET_MODE (operands[0]))
    {
    case SFmode:
      if (!nvptx_register_operand (operands[0], SFmode))
        return -1;
      return pattern25 (x7, SFmode); /* [-1, 1] */

    case DFmode:
      if (!nvptx_register_operand (operands[0], DFmode))
        return -1;
      res = pattern25 (x7, DFmode);
      if (res >= 0)
        return res + 2; /* [2, 3] */
      return -1;

    default:
      return -1;
    }
}

static int
pattern27 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!nvptx_register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  switch (GET_MODE (operands[1]))
    {
    case SFmode:
      if (!nvptx_register_operand (operands[1], SFmode))
        return -1;
      return 0;

    case DFmode:
      if (!nvptx_register_operand (operands[1], DFmode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

static int
pattern28 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[2] = x2;
  x3 = XEXP (x2, 0);
  operands[3] = x3;
  x4 = XEXP (x2, 1);
  operands[4] = x4;
  x5 = XEXP (x1, 1);
  x6 = XEXP (x5, 0);
  operands[0] = x6;
  x7 = XEXP (x5, 1);
  x8 = XEXP (x7, 0);
  operands[1] = x8;
  switch (GET_MODE (operands[0]))
    {
    case SImode:
      return pattern27 (x7, SImode); /* [-1, 1] */

    case DImode:
      res = pattern27 (x7, DImode);
      if (res >= 0)
        return res + 2; /* [2, 3] */
      return -1;

    default:
      return -1;
    }
}

static int
pattern29 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!nvptx_register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !nvptx_register_operand (operands[1], i1)
      || !nvptx_nonmemory_operand (operands[2], i1)
      || !nvptx_nonmemory_operand (operands[3], i1))
    return -1;
  return 0;
}

static int
pattern30 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!nvptx_register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !nvptx_register_operand (operands[1], i1)
      || !nvptx_register_operand (operands[2], i1))
    return -1;
  return 0;
}

static int
pattern31 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!nvptx_register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !nvptx_register_operand (operands[1], i1)
      || !nvptx_nonmemory_operand (operands[2], i1)
      || !nvptx_nonmemory_operand (operands[3], i1))
    return -1;
  return 0;
}

static int
pattern32 (machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!nvptx_register_operand (operands[0], i1)
      || !nvptx_comparison_operator (operands[1], i1))
    return -1;
  switch (GET_MODE (operands[2]))
    {
    case HImode:
      if (!nvptx_register_operand (operands[2], HImode)
          || !nvptx_nonmemory_operand (operands[3], HImode))
        return -1;
      return 0;

    case SImode:
      if (!nvptx_register_operand (operands[2], SImode)
          || !nvptx_nonmemory_operand (operands[3], SImode))
        return -1;
      return 1;

    case DImode:
      if (!nvptx_register_operand (operands[2], DImode)
          || !nvptx_nonmemory_operand (operands[3], DImode))
        return -1;
      return 2;

    default:
      return -1;
    }
}

static int
pattern33 (machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!nvptx_register_operand (operands[0], i1)
      || !nvptx_float_comparison_operator (operands[1], i1))
    return -1;
  switch (GET_MODE (operands[2]))
    {
    case SFmode:
      if (!nvptx_register_operand (operands[2], SFmode)
          || !nvptx_nonmemory_operand (operands[3], SFmode))
        return -1;
      return 0;

    case DFmode:
      if (!nvptx_register_operand (operands[2], DFmode)
          || !nvptx_nonmemory_operand (operands[3], DFmode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

static int
pattern34 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!nvptx_register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  switch (GET_MODE (operands[1]))
    {
    case SFmode:
      if (!nvptx_register_operand (operands[1], SFmode))
        return -1;
      return 0;

    case DFmode:
      if (!nvptx_register_operand (operands[1], DFmode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

static int
pattern35 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[2] = x2;
  x3 = XEXP (x2, 0);
  operands[3] = x3;
  x4 = XEXP (x2, 1);
  operands[4] = x4;
  x5 = XEXP (x1, 1);
  x6 = XEXP (x5, 1);
  x7 = XVECEXP (x6, 0, 0);
  operands[1] = x7;
  switch (GET_MODE (operands[0]))
    {
    case SFmode:
      if (!nvptx_register_operand (operands[0], SFmode)
          || GET_MODE (x6) != SFmode
          || !nvptx_register_operand (operands[1], SFmode))
        return -1;
      return 0;

    case DFmode:
      if (!nvptx_register_operand (operands[0], DFmode)
          || GET_MODE (x6) != DFmode
          || !nvptx_register_operand (operands[1], DFmode))
        return -1;
      return 1;

    case SImode:
      res = pattern34 (x6, SImode);
      if (res >= 0)
        return res + 2; /* [2, 3] */
      return -1;

    case DImode:
      res = pattern34 (x6, DImode);
      if (res >= 0)
        return res + 4; /* [4, 5] */
      return -1;

    default:
      return -1;
    }
}

static int
pattern36 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[2] = x2;
  x3 = XEXP (x2, 0);
  operands[3] = x3;
  x4 = XEXP (x2, 1);
  operands[4] = x4;
  x5 = XEXP (x1, 1);
  x6 = XEXP (x5, 1);
  x7 = XVECEXP (x6, 0, 0);
  operands[1] = x7;
  switch (GET_MODE (operands[0]))
    {
    case SFmode:
      if (!nvptx_register_operand (operands[0], SFmode)
          || GET_MODE (x6) != SFmode
          || !nvptx_register_operand (operands[1], SFmode))
        return -1;
      return 0;

    case DFmode:
      if (!nvptx_register_operand (operands[0], DFmode)
          || GET_MODE (x6) != DFmode
          || !nvptx_register_operand (operands[1], DFmode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

static int
pattern37 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!nvptx_register_operand (operands[0], SImode)
      || GET_MODE (x1) != SImode)
    return -1;
  switch (GET_MODE (operands[1]))
    {
    case QImode:
      if (!nvptx_nonimmediate_operand (operands[1], QImode))
        return -1;
      return 0;

    case HImode:
      if (!nvptx_nonimmediate_operand (operands[1], HImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

static int
pattern38 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!nvptx_register_operand (operands[0], DImode)
      || GET_MODE (x1) != DImode)
    return -1;
  switch (GET_MODE (operands[1]))
    {
    case QImode:
      if (!nvptx_nonimmediate_operand (operands[1], QImode))
        return -1;
      return 0;

    case HImode:
      if (!nvptx_nonimmediate_operand (operands[1], HImode))
        return -1;
      return 1;

    case SImode:
      if (!nvptx_nonimmediate_operand (operands[1], SImode))
        return -1;
      return 2;

    default:
      return -1;
    }
}

static int
pattern39 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!nvptx_register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !nvptx_register_operand (operands[1], i1)
      || !nvptx_register_operand (operands[2], i1))
    return -1;
  return 0;
}

static int
pattern40 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!nvptx_register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !nvptx_nonmemory_operand (operands[2], i1)
      || !nvptx_nonmemory_operand (operands[3], i1))
    return -1;
  return 0;
}

static int
pattern41 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 1);
  if (x3 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x4 = XEXP (x2, 0);
  operands[1] = x4;
  if (!nvptx_register_operand (operands[1], BImode))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case HImode:
      return pattern40 (x1, HImode); /* [-1, 0] */

    case SImode:
      if (pattern40 (x1, SImode) != 0)
        return -1;
      return 1;

    case DImode:
      if (pattern40 (x1, DImode) != 0)
        return -1;
      return 2;

    case SFmode:
      if (pattern40 (x1, SFmode) != 0)
        return -1;
      return 3;

    case DFmode:
      if (pattern40 (x1, DFmode) != 0)
        return -1;
      return 4;

    default:
      return -1;
    }
}

static int
pattern42 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!nvptx_register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !memory_operand (operands[1], i1)
      || !nvptx_nonmemory_operand (operands[2], i1))
    return -1;
  return 0;
}

static int
pattern43 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!nvptx_register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !nvptx_register_operand (operands[1], i1)
      || !nvptx_nonmemory_operand (operands[2], i1)
      || !nvptx_nonmemory_operand (operands[3], i1))
    return -1;
  return 0;
}

static int
pattern44 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!nvptx_register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !nvptx_register_operand (operands[1], i1)
      || !nvptx_register_operand (operands[2], i1))
    return -1;
  return 0;
}

static int
pattern45 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!nvptx_register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !nvptx_register_operand (operands[1], i1)
      || !nvptx_nonmemory_operand (operands[2], i1)
      || !nvptx_nonmemory_operand (operands[3], i1))
    return -1;
  return 0;
}

static int
pattern46 (machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!nvptx_register_operand (operands[0], i1)
      || !nvptx_comparison_operator (operands[1], i1))
    return -1;
  switch (GET_MODE (operands[2]))
    {
    case HImode:
      if (!nvptx_register_operand (operands[2], HImode)
          || !nvptx_nonmemory_operand (operands[3], HImode))
        return -1;
      return 0;

    case SImode:
      if (!nvptx_register_operand (operands[2], SImode)
          || !nvptx_nonmemory_operand (operands[3], SImode))
        return -1;
      return 1;

    case DImode:
      if (!nvptx_register_operand (operands[2], DImode)
          || !nvptx_nonmemory_operand (operands[3], DImode))
        return -1;
      return 2;

    default:
      return -1;
    }
}

static int
pattern47 (machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!nvptx_register_operand (operands[0], i1)
      || !nvptx_float_comparison_operator (operands[1], i1))
    return -1;
  switch (GET_MODE (operands[2]))
    {
    case SFmode:
      if (!nvptx_register_operand (operands[2], SFmode)
          || !nvptx_nonmemory_operand (operands[3], SFmode))
        return -1;
      return 0;

    case DFmode:
      if (!nvptx_register_operand (operands[2], DFmode)
          || !nvptx_nonmemory_operand (operands[3], DFmode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

static int
pattern48 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!memory_operand (operands[1], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  if (GET_MODE (x2) != i1
      || !nvptx_nonmemory_operand (operands[2], i1)
      || !nvptx_register_operand (operands[0], i1))
    return -1;
  return 0;
}

static int
pattern49 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  if (!nvptx_register_operand (operands[0], i1))
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) != i1
      || !memory_operand (operands[1], i1)
      || !nvptx_nonmemory_operand (operands[2], i1)
      || !nvptx_nonmemory_operand (operands[3], i1))
    return -1;
  x4 = XVECEXP (x1, 0, 1);
  x5 = XEXP (x4, 1);
  if (GET_MODE (x5) != i1)
    return -1;
  return 0;
}

static int
pattern50 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!nvptx_register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !memory_operand (operands[1], i1)
      || !nvptx_nonmemory_operand (operands[2], i1))
    return -1;
  return 0;
}

static int
pattern51 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!memory_operand (operands[1], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  if (GET_MODE (x2) != i1
      || !nvptx_nonmemory_operand (operands[2], i1)
      || !nvptx_register_operand (operands[0], i1))
    return -1;
  return 0;
}

static int
pattern52 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  if (!nvptx_register_operand (operands[0], i1))
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) != i1
      || !memory_operand (operands[1], i1)
      || !nvptx_nonmemory_operand (operands[2], i1)
      || !nvptx_nonmemory_operand (operands[3], i1))
    return -1;
  x4 = XVECEXP (x1, 0, 1);
  x5 = XEXP (x4, 1);
  if (GET_MODE (x5) != i1)
    return -1;
  return 0;
}

static int
recog_1 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  operands[1] = x2;
  x3 = XEXP (x2, 0);
  operands[2] = x3;
  x4 = XEXP (x2, 1);
  operands[3] = x4;
  switch (GET_MODE (operands[0]))
    {
    case BImode:
      switch (pattern32 (BImode))
        {
        case 0:
          return 98; /* *cmphi */

        case 1:
          return 99; /* *cmpsi */

        case 2:
          return 100; /* *cmpdi */

        default:
          break;
        }
      break;

    case SImode:
      switch (pattern32 (SImode))
        {
        case 0:
          return 119; /* setcc_inthi */

        case 1:
          return 120; /* setcc_intsi */

        case 2:
          return 121; /* setcc_intdi */

        default:
          break;
        }
      break;

    case SFmode:
      switch (pattern32 (SFmode))
        {
        case 0:
          return 124; /* setcc_floathi */

        case 1:
          return 125; /* setcc_floatsi */

        case 2:
          return 126; /* setcc_floatdi */

        default:
          break;
        }
      break;

    default:
      break;
    }
  if (GET_CODE (x2) != NE
      || GET_MODE (x2) != SImode
      || x4 != const_int_rtx[MAX_SAVED_CONST_INT + 0]
      || !nvptx_register_operand (operands[0], SImode))
    return -1;
  operands[1] = x3;
  if (!nvptx_register_operand (operands[1], BImode))
    return -1;
  return 108; /* setcc_from_bi */
}

static int
recog_2 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  switch (GET_CODE (x2))
    {
    case CALL:
      x3 = XEXP (x2, 0);
      if (GET_CODE (x3) != MEM
          || GET_MODE (x3) != QImode)
        return -1;
      operands[2] = x1;
      x4 = XEXP (x3, 0);
      operands[0] = x4;
      if (!call_insn_operand (operands[0], VOIDmode))
        return -1;
      x5 = XEXP (x2, 1);
      operands[1] = x5;
      return 129; /* call_insn */

    case SET:
      x5 = XEXP (x2, 1);
      if (GET_CODE (x5) != CALL)
        return -1;
      x6 = XEXP (x5, 0);
      if (GET_CODE (x6) != MEM
          || GET_MODE (x6) != QImode)
        return -1;
      operands[3] = x1;
      x3 = XEXP (x2, 0);
      operands[0] = x3;
      if (!nvptx_register_operand (operands[0], VOIDmode))
        return -1;
      x7 = XEXP (x6, 0);
      operands[1] = x7;
      if (!call_insn_operand (operands[1], VOIDmode))
        return -1;
      x8 = XEXP (x5, 1);
      operands[2] = x8;
      return 130; /* call_value_insn */

    default:
      return -1;
    }
}

static int
recog_3 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[2] = x2;
  x3 = XEXP (x2, 0);
  operands[3] = x3;
  x4 = XEXP (x2, 1);
  operands[4] = x4;
  x5 = XEXP (x1, 1);
  x6 = XEXP (x5, 0);
  operands[0] = x6;
  switch (GET_MODE (operands[0]))
    {
    case BImode:
      if (!nvptx_register_operand (operands[0], BImode)
          || !nvptx_nonmemory_operand (operands[1], BImode))
        return -1;
      return 263; /* *p movbi */

    case QImode:
      if (!nonimmediate_operand (operands[0], QImode)
          || !general_operand (operands[1], QImode)
          || !
#line 206 "../../gcc/config/nvptx/nvptx.md"
(!MEM_P (operands[0]) || REG_P (operands[1])))
        return -1;
      return 264; /* *p *movqi_insn */

    case HImode:
      if (!nonimmediate_operand (operands[0], HImode)
          || !general_operand (operands[1], HImode)
          || !
#line 206 "../../gcc/config/nvptx/nvptx.md"
(!MEM_P (operands[0]) || REG_P (operands[1])))
        return -1;
      return 265; /* *p *movhi_insn */

    case SImode:
      if (!nonimmediate_operand (operands[0], SImode)
          || !general_operand (operands[1], SImode)
          || !
#line 206 "../../gcc/config/nvptx/nvptx.md"
(!MEM_P (operands[0]) || REG_P (operands[1])))
        return -1;
      return 266; /* *p *movsi_insn */

    case DImode:
      if (!nonimmediate_operand (operands[0], DImode)
          || !general_operand (operands[1], DImode)
          || !
#line 206 "../../gcc/config/nvptx/nvptx.md"
(!MEM_P (operands[0]) || REG_P (operands[1])))
        return -1;
      return 267; /* *p *movdi_insn */

    case SFmode:
      if (!nonimmediate_operand (operands[0], SFmode)
          || !general_operand (operands[1], SFmode)
          || !
#line 220 "../../gcc/config/nvptx/nvptx.md"
(!MEM_P (operands[0]) || REG_P (operands[1])))
        return -1;
      return 268; /* *p *movsf_insn */

    case DFmode:
      if (!nonimmediate_operand (operands[0], DFmode)
          || !general_operand (operands[1], DFmode)
          || !
#line 220 "../../gcc/config/nvptx/nvptx.md"
(!MEM_P (operands[0]) || REG_P (operands[1])))
        return -1;
      return 269; /* *p *movdf_insn */

    default:
      return -1;
    }
}

static int
recog_4 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[4] = x2;
  x3 = XEXP (x2, 0);
  operands[5] = x3;
  x4 = XEXP (x2, 1);
  operands[6] = x4;
  x5 = XEXP (x1, 1);
  x6 = XEXP (x5, 1);
  x7 = XEXP (x6, 0);
  operands[2] = x7;
  x8 = XEXP (x6, 1);
  operands[3] = x8;
  switch (GET_MODE (operands[0]))
    {
    case BImode:
      switch (pattern46 (BImode))
        {
        case 0:
          return 360; /* *p *cmphi */

        case 1:
          return 361; /* *p *cmpsi */

        case 2:
          return 362; /* *p *cmpdi */

        default:
          return -1;
        }

    case SImode:
      switch (pattern46 (SImode))
        {
        case 0:
          return 377; /* *p setcc_inthi */

        case 1:
          return 378; /* *p setcc_intsi */

        case 2:
          return 379; /* *p setcc_intdi */

        default:
          return -1;
        }

    case SFmode:
      switch (pattern46 (SFmode))
        {
        case 0:
          return 382; /* *p setcc_floathi */

        case 1:
          return 383; /* *p setcc_floatsi */

        case 2:
          return 384; /* *p setcc_floatdi */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

static int
recog_5 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  operands[1] = x3;
  res = recog_4 (x1, insn, pnum_clobbers);
  if (res >= 0)
    return res;
  if (GET_CODE (x3) != NE
      || GET_MODE (x3) != SImode)
    return -1;
  x4 = XEXP (x3, 1);
  if (x4 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x5 = XEXP (x1, 0);
  operands[2] = x5;
  x6 = XEXP (x5, 0);
  operands[3] = x6;
  x7 = XEXP (x5, 1);
  operands[4] = x7;
  if (!nvptx_register_operand (operands[0], SImode))
    return -1;
  x8 = XEXP (x3, 0);
  operands[1] = x8;
  if (!nvptx_register_operand (operands[1], BImode))
    return -1;
  return 366; /* *p setcc_from_bi */
}

static int
recog_6 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XVECEXP (x2, 0, 0);
  switch (GET_CODE (x3))
    {
    case CALL:
      x4 = XEXP (x3, 0);
      if (GET_CODE (x4) != MEM
          || GET_MODE (x4) != QImode)
        return -1;
      x5 = XEXP (x1, 0);
      operands[3] = x5;
      x6 = XEXP (x5, 0);
      operands[4] = x6;
      x7 = XEXP (x5, 1);
      operands[5] = x7;
      operands[2] = x2;
      x8 = XEXP (x4, 0);
      operands[0] = x8;
      if (!call_insn_operand (operands[0], VOIDmode))
        return -1;
      x9 = XEXP (x3, 1);
      operands[1] = x9;
      return 387; /* *p call_insn */

    case SET:
      x9 = XEXP (x3, 1);
      if (GET_CODE (x9) != CALL)
        return -1;
      x10 = XEXP (x9, 0);
      if (GET_CODE (x10) != MEM
          || GET_MODE (x10) != QImode)
        return -1;
      x5 = XEXP (x1, 0);
      operands[4] = x5;
      x6 = XEXP (x5, 0);
      operands[5] = x6;
      x7 = XEXP (x5, 1);
      operands[6] = x7;
      operands[3] = x2;
      x4 = XEXP (x3, 0);
      operands[0] = x4;
      if (!nvptx_register_operand (operands[0], VOIDmode))
        return -1;
      x11 = XEXP (x10, 0);
      operands[1] = x11;
      if (!call_insn_operand (operands[1], VOIDmode))
        return -1;
      x12 = XEXP (x9, 1);
      operands[2] = x12;
      return 388; /* *p call_value_insn */

    default:
      return -1;
    }
}

static int
recog_7 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  switch (GET_CODE (x3))
    {
    case CONST_INT:
    case CONST_WIDE_INT:
    case CONST_FIXED:
    case CONST_DOUBLE:
    case CONST_VECTOR:
    case CONST:
    case REG:
    case SUBREG:
    case MEM:
    case LABEL_REF:
    case SYMBOL_REF:
    case HIGH:
      operands[1] = x3;
      res = recog_3 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
      if (GET_CODE (x3) != LABEL_REF)
        return -1;
      x4 = XEXP (x2, 0);
      if (GET_CODE (x4) != PC)
        return -1;
      x5 = XEXP (x1, 0);
      operands[1] = x5;
      x6 = XEXP (x5, 0);
      operands[2] = x6;
      x7 = XEXP (x5, 1);
      operands[3] = x7;
      x8 = XEXP (x3, 0);
      operands[0] = x8;
      return 365; /* *p jump */

    case UNSPEC:
      x4 = XEXP (x2, 0);
      operands[0] = x4;
      switch (XVECLEN (x3, 0))
        {
        case 1:
          switch (XINT (x3, 1))
            {
            case 0:
              x5 = XEXP (x1, 0);
              operands[2] = x5;
              x6 = XEXP (x5, 0);
              operands[3] = x6;
              x7 = XEXP (x5, 1);
              operands[4] = x7;
              x9 = XVECEXP (x3, 0, 0);
              operands[1] = x9;
              if (!const_int_operand (operands[1], VOIDmode))
                return -1;
              switch (GET_MODE (operands[0]))
                {
                case QImode:
                  if (!nvptx_register_operand (operands[0], QImode)
                      || GET_MODE (x3) != QImode)
                    return -1;
                  return 270; /* *p load_arg_regqi */

                case HImode:
                  if (!nvptx_register_operand (operands[0], HImode)
                      || GET_MODE (x3) != HImode)
                    return -1;
                  return 271; /* *p load_arg_reghi */

                case SImode:
                  if (!nvptx_register_operand (operands[0], SImode)
                      || GET_MODE (x3) != SImode)
                    return -1;
                  return 272; /* *p load_arg_regsi */

                case DImode:
                  if (!nvptx_register_operand (operands[0], DImode)
                      || GET_MODE (x3) != DImode)
                    return -1;
                  return 273; /* *p load_arg_regdi */

                case SFmode:
                  if (!nvptx_register_operand (operands[0], SFmode)
                      || GET_MODE (x3) != SFmode)
                    return -1;
                  return 274; /* *p load_arg_regsf */

                case DFmode:
                  if (!nvptx_register_operand (operands[0], DFmode)
                      || GET_MODE (x3) != DFmode)
                    return -1;
                  return 275; /* *p load_arg_regdf */

                default:
                  return -1;
                }

            case 10:
              x5 = XEXP (x1, 0);
              operands[2] = x5;
              x6 = XEXP (x5, 0);
              operands[3] = x6;
              x7 = XEXP (x5, 1);
              operands[4] = x7;
              x9 = XVECEXP (x3, 0, 0);
              operands[1] = x9;
              switch (GET_MODE (operands[0]))
                {
                case SImode:
                  if (!nvptx_register_operand (operands[0], SImode)
                      || GET_MODE (x3) != SImode
                      || !nvptx_register_operand (operands[1], SImode))
                    return -1;
                  return 338; /* *p bitrevsi2 */

                case DImode:
                  if (!nvptx_register_operand (operands[0], DImode)
                      || GET_MODE (x3) != DImode
                      || !nvptx_register_operand (operands[1], DImode))
                    return -1;
                  return 339; /* *p bitrevdi2 */

                default:
                  return -1;
                }

            case 4:
              if (GET_MODE (x3) != SFmode)
                return -1;
              x5 = XEXP (x1, 0);
              operands[2] = x5;
              x6 = XEXP (x5, 0);
              operands[3] = x6;
              x7 = XEXP (x5, 1);
              operands[4] = x7;
              if (!nvptx_register_operand (operands[0], SFmode))
                return -1;
              x9 = XVECEXP (x3, 0, 0);
              operands[1] = x9;
              if (!nvptx_register_operand (operands[1], SFmode)
                  || !
#line 841 "../../gcc/config/nvptx/nvptx.md"
(flag_unsafe_math_optimizations))
                return -1;
              return 411; /* *p sinsf2 */

            case 5:
              if (GET_MODE (x3) != SFmode)
                return -1;
              x5 = XEXP (x1, 0);
              operands[2] = x5;
              x6 = XEXP (x5, 0);
              operands[3] = x6;
              x7 = XEXP (x5, 1);
              operands[4] = x7;
              if (!nvptx_register_operand (operands[0], SFmode))
                return -1;
              x9 = XVECEXP (x3, 0, 0);
              operands[1] = x9;
              if (!nvptx_register_operand (operands[1], SFmode)
                  || !
#line 848 "../../gcc/config/nvptx/nvptx.md"
(flag_unsafe_math_optimizations))
                return -1;
              return 412; /* *p cossf2 */

            case 2:
              if (GET_MODE (x3) != SFmode)
                return -1;
              x5 = XEXP (x1, 0);
              operands[2] = x5;
              x6 = XEXP (x5, 0);
              operands[3] = x6;
              x7 = XEXP (x5, 1);
              operands[4] = x7;
              if (!nvptx_register_operand (operands[0], SFmode))
                return -1;
              x9 = XVECEXP (x3, 0, 0);
              operands[1] = x9;
              if (!nvptx_register_operand (operands[1], SFmode)
                  || !
#line 855 "../../gcc/config/nvptx/nvptx.md"
(flag_unsafe_math_optimizations))
                return -1;
              return 413; /* *p log2sf2 */

            case 3:
              if (GET_MODE (x3) != SFmode)
                return -1;
              x5 = XEXP (x1, 0);
              operands[2] = x5;
              x6 = XEXP (x5, 0);
              operands[3] = x6;
              x7 = XEXP (x5, 1);
              operands[4] = x7;
              if (!nvptx_register_operand (operands[0], SFmode))
                return -1;
              x9 = XVECEXP (x3, 0, 0);
              operands[1] = x9;
              if (!nvptx_register_operand (operands[1], SFmode)
                  || !
#line 862 "../../gcc/config/nvptx/nvptx.md"
(flag_unsafe_math_optimizations))
                return -1;
              return 414; /* *p exp2sf2 */

            case 6:
              switch (pattern35 (x1))
                {
                case 0:
                  return 433; /* *p floorsf2 */

                case 1:
                  return 437; /* *p floordf2 */

                case 2:
                  return 441; /* *p lfloorsfsi2 */

                case 3:
                  return 443; /* *p lfloordfsi2 */

                case 4:
                  return 445; /* *p lfloorsfdi2 */

                case 5:
                  return 447; /* *p lfloordfdi2 */

                default:
                  return -1;
                }

            case 7:
              switch (pattern36 (x1))
                {
                case 0:
                  return 434; /* *p btruncsf2 */

                case 1:
                  return 438; /* *p btruncdf2 */

                default:
                  return -1;
                }

            case 8:
              switch (pattern35 (x1))
                {
                case 0:
                  return 435; /* *p ceilsf2 */

                case 1:
                  return 439; /* *p ceildf2 */

                case 2:
                  return 442; /* *p lceilsfsi2 */

                case 3:
                  return 444; /* *p lceildfsi2 */

                case 4:
                  return 446; /* *p lceilsfdi2 */

                case 5:
                  return 448; /* *p lceildfdi2 */

                default:
                  return -1;
                }

            case 9:
              switch (pattern36 (x1))
                {
                case 0:
                  return 436; /* *p nearbyintsf2 */

                case 1:
                  return 440; /* *p nearbyintdf2 */

                default:
                  return -1;
                }

            case 13:
              if (GET_MODE (x3) != SImode)
                return -1;
              x5 = XEXP (x1, 0);
              operands[2] = x5;
              x6 = XEXP (x5, 0);
              operands[3] = x6;
              x7 = XEXP (x5, 1);
              operands[4] = x7;
              if (!nvptx_register_operand (operands[0], SImode))
                return -1;
              x9 = XVECEXP (x3, 0, 0);
              operands[1] = x9;
              if (!const_int_operand (operands[1], SImode))
                return -1;
              return 452; /* *p oacc_dim_size */

            case 15:
              if (GET_MODE (x3) != SImode)
                return -1;
              x5 = XEXP (x1, 0);
              operands[2] = x5;
              x6 = XEXP (x5, 0);
              operands[3] = x6;
              x7 = XEXP (x5, 1);
              operands[4] = x7;
              if (!nvptx_register_operand (operands[0], SImode))
                return -1;
              x9 = XVECEXP (x3, 0, 0);
              operands[1] = x9;
              if (!nvptx_register_operand (operands[1], BImode))
                return -1;
              return 456; /* *p nvptx_vote_ballot */

            case 16:
              if (GET_MODE (x3) != SImode)
                return -1;
              x9 = XVECEXP (x3, 0, 0);
              if (x9 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
                return -1;
              x5 = XEXP (x1, 0);
              operands[1] = x5;
              x6 = XEXP (x5, 0);
              operands[2] = x6;
              x7 = XEXP (x5, 1);
              operands[3] = x7;
              if (!nvptx_register_operand (operands[0], SImode))
                return -1;
              return 459; /* *p omp_simt_lane */

            default:
              return -1;
            }

        case 2:
          x5 = XEXP (x1, 0);
          operands[3] = x5;
          x6 = XEXP (x5, 0);
          operands[4] = x6;
          x7 = XEXP (x5, 1);
          operands[5] = x7;
          x9 = XVECEXP (x3, 0, 0);
          operands[1] = x9;
          x10 = XVECEXP (x3, 0, 1);
          operands[2] = x10;
          switch (XINT (x3, 1))
            {
            case 1:
              switch (GET_MODE (operands[0]))
                {
                case SFmode:
                  if (pattern44 (x3, SFmode) != 0)
                    return -1;
                  return 399; /* *p copysignsf3 */

                case DFmode:
                  if (pattern44 (x3, DFmode) != 0)
                    return -1;
                  return 400; /* *p copysigndf3 */

                default:
                  return -1;
                }

            case 14:
              if (!nvptx_register_operand (operands[1], SImode)
                  || !nvptx_register_operand (operands[2], SImode))
                return -1;
              switch (GET_MODE (operands[0]))
                {
                case DImode:
                  if (!nvptx_register_operand (operands[0], DImode)
                      || GET_MODE (x3) != DImode)
                    return -1;
                  return 462; /* *p packsidi2 */

                case DFmode:
                  if (!nvptx_register_operand (operands[0], DFmode)
                      || GET_MODE (x3) != DFmode)
                    return -1;
                  return 463; /* *p packsidf2 */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        case 3:
          if (XINT (x3, 1) != 17)
            return -1;
          x5 = XEXP (x1, 0);
          operands[4] = x5;
          x6 = XEXP (x5, 0);
          operands[5] = x6;
          x7 = XEXP (x5, 1);
          operands[6] = x7;
          x9 = XVECEXP (x3, 0, 0);
          operands[1] = x9;
          x10 = XVECEXP (x3, 0, 1);
          operands[2] = x10;
          if (!nvptx_nonmemory_operand (operands[2], SImode))
            return -1;
          x11 = XVECEXP (x3, 0, 2);
          operands[3] = x11;
          if (!const_int_operand (operands[3], SImode))
            return -1;
          switch (GET_MODE (operands[0]))
            {
            case SImode:
              if (!nvptx_register_operand (operands[0], SImode)
                  || GET_MODE (x3) != SImode
                  || !nvptx_register_operand (operands[1], SImode))
                return -1;
              return 454; /* *p nvptx_shufflesi */

            case SFmode:
              if (!nvptx_register_operand (operands[0], SFmode)
                  || GET_MODE (x3) != SFmode
                  || !nvptx_register_operand (operands[1], SFmode))
                return -1;
              return 455; /* *p nvptx_shufflesf */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case ZERO_EXTEND:
      x5 = XEXP (x1, 0);
      operands[2] = x5;
      x6 = XEXP (x5, 0);
      operands[3] = x6;
      x7 = XEXP (x5, 1);
      operands[4] = x7;
      x4 = XEXP (x2, 0);
      operands[0] = x4;
      x8 = XEXP (x3, 0);
      operands[1] = x8;
      switch (GET_MODE (operands[0]))
        {
        case HImode:
          if (!nvptx_register_operand (operands[0], HImode)
              || GET_MODE (x3) != HImode
              || !nvptx_nonimmediate_operand (operands[1], QImode))
            return -1;
          return 276; /* *p zero_extendqihi2 */

        case SImode:
          switch (pattern37 (x3))
            {
            case 0:
              return 277; /* *p zero_extendqisi2 */

            case 1:
              return 278; /* *p zero_extendhisi2 */

            default:
              return -1;
            }

        case DImode:
          switch (pattern38 (x3))
            {
            case 0:
              return 279; /* *p zero_extendqidi2 */

            case 1:
              return 280; /* *p zero_extendhidi2 */

            case 2:
              return 281; /* *p zero_extendsidi2 */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case SIGN_EXTEND:
      x5 = XEXP (x1, 0);
      operands[2] = x5;
      x6 = XEXP (x5, 0);
      operands[3] = x6;
      x7 = XEXP (x5, 1);
      operands[4] = x7;
      x4 = XEXP (x2, 0);
      operands[0] = x4;
      x8 = XEXP (x3, 0);
      operands[1] = x8;
      switch (GET_MODE (operands[0]))
        {
        case SImode:
          switch (pattern37 (x3))
            {
            case 0:
              return 282; /* *p extendqisi2 */

            case 1:
              return 283; /* *p extendhisi2 */

            default:
              return -1;
            }

        case DImode:
          switch (pattern38 (x3))
            {
            case 0:
              return 284; /* *p extendqidi2 */

            case 1:
              return 285; /* *p extendhidi2 */

            case 2:
              return 286; /* *p extendsidi2 */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case TRUNCATE:
      x5 = XEXP (x1, 0);
      operands[2] = x5;
      x6 = XEXP (x5, 0);
      operands[3] = x6;
      x7 = XEXP (x5, 1);
      operands[4] = x7;
      x4 = XEXP (x2, 0);
      operands[0] = x4;
      x8 = XEXP (x3, 0);
      operands[1] = x8;
      switch (GET_MODE (operands[0]))
        {
        case QImode:
          if (!nvptx_nonimmediate_operand (operands[0], QImode)
              || GET_MODE (x3) != QImode)
            return -1;
          switch (GET_MODE (operands[1]))
            {
            case HImode:
              if (!nvptx_register_operand (operands[1], HImode))
                return -1;
              return 287; /* *p trunchiqi2 */

            case SImode:
              if (!nvptx_register_operand (operands[1], SImode))
                return -1;
              return 288; /* *p truncsiqi2 */

            case DImode:
              if (!nvptx_register_operand (operands[1], DImode))
                return -1;
              return 290; /* *p truncdiqi2 */

            default:
              return -1;
            }

        case HImode:
          if (!nvptx_nonimmediate_operand (operands[0], HImode))
            return -1;
          switch (pattern25 (x3, HImode))
            {
            case 0:
              return 289; /* *p truncsihi2 */

            case 1:
              return 291; /* *p truncdihi2 */

            default:
              return -1;
            }

        case SImode:
          if (!nvptx_nonimmediate_operand (operands[0], SImode)
              || GET_MODE (x3) != SImode
              || !nvptx_register_operand (operands[1], DImode))
            return -1;
          return 292; /* *p truncdisi2 */

        default:
          return -1;
        }

    case PLUS:
      x4 = XEXP (x2, 0);
      operands[0] = x4;
      x8 = XEXP (x3, 0);
      switch (GET_CODE (x8))
        {
        case REG:
          operands[1] = x8;
          x5 = XEXP (x1, 0);
          operands[3] = x5;
          x6 = XEXP (x5, 0);
          operands[4] = x6;
          x7 = XEXP (x5, 1);
          operands[5] = x7;
          switch (pattern19 (x3))
            {
            case 0:
              return 293; /* *p addhi3 */

            case 1:
              return 294; /* *p addsi3 */

            case 2:
              return 295; /* *p adddi3 */

            case 3:
              return 389; /* *p addsf3 */

            case 4:
              return 390; /* *p adddf3 */

            default:
              return -1;
            }

        case MULT:
          x5 = XEXP (x1, 0);
          operands[4] = x5;
          x6 = XEXP (x5, 0);
          operands[5] = x6;
          x7 = XEXP (x5, 1);
          operands[6] = x7;
          x12 = XEXP (x8, 0);
          operands[1] = x12;
          x13 = XEXP (x8, 1);
          operands[2] = x13;
          x14 = XEXP (x3, 1);
          operands[3] = x14;
          switch (GET_MODE (operands[0]))
            {
            case HImode:
              if (pattern45 (x3, HImode) != 0)
                return -1;
              return 302; /* *p *madhi3 */

            case SImode:
              if (pattern45 (x3, SImode) != 0)
                return -1;
              return 303; /* *p *madsi3 */

            case DImode:
              if (pattern45 (x3, DImode) != 0)
                return -1;
              return 304; /* *p *maddi3 */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case MINUS:
      x5 = XEXP (x1, 0);
      operands[3] = x5;
      x6 = XEXP (x5, 0);
      operands[4] = x6;
      x7 = XEXP (x5, 1);
      operands[5] = x7;
      x4 = XEXP (x2, 0);
      operands[0] = x4;
      x8 = XEXP (x3, 0);
      operands[1] = x8;
      x14 = XEXP (x3, 1);
      operands[2] = x14;
      switch (GET_MODE (operands[0]))
        {
        case HImode:
          if (pattern39 (x3, HImode) != 0)
            return -1;
          return 296; /* *p subhi3 */

        case SImode:
          if (pattern39 (x3, SImode) != 0)
            return -1;
          return 297; /* *p subsi3 */

        case DImode:
          if (pattern39 (x3, DImode) != 0)
            return -1;
          return 298; /* *p subdi3 */

        case SFmode:
          if (pattern39 (x3, SFmode) != 0)
            return -1;
          return 391; /* *p subsf3 */

        case DFmode:
          if (pattern39 (x3, DFmode) != 0)
            return -1;
          return 392; /* *p subdf3 */

        default:
          return -1;
        }

    case MULT:
      switch (pattern20 (x1))
        {
        case 0:
          return 299; /* *p mulhi3 */

        case 1:
          return 300; /* *p mulsi3 */

        case 2:
          return 301; /* *p muldi3 */

        case 3:
          return 393; /* *p mulsf3 */

        case 4:
          return 394; /* *p muldf3 */

        default:
          return -1;
        }

    case DIV:
      switch (pattern20 (x1))
        {
        case 0:
          return 305; /* *p divhi3 */

        case 1:
          return 306; /* *p divsi3 */

        case 2:
          return 307; /* *p divdi3 */

        case 3:
          return 397; /* *p divsf3 */

        case 4:
          return 398; /* *p divdf3 */

        default:
          return -1;
        }

    case UDIV:
      switch (pattern21 (x1))
        {
        case 0:
          return 308; /* *p udivhi3 */

        case 1:
          return 309; /* *p udivsi3 */

        case 2:
          return 310; /* *p udivdi3 */

        default:
          return -1;
        }

    case MOD:
      switch (pattern21 (x1))
        {
        case 0:
          return 311; /* *p modhi3 */

        case 1:
          return 312; /* *p modsi3 */

        case 2:
          return 313; /* *p moddi3 */

        default:
          return -1;
        }

    case UMOD:
      switch (pattern21 (x1))
        {
        case 0:
          return 314; /* *p umodhi3 */

        case 1:
          return 315; /* *p umodsi3 */

        case 2:
          return 316; /* *p umoddi3 */

        default:
          return -1;
        }

    case SMIN:
      switch (pattern20 (x1))
        {
        case 0:
          return 317; /* *p sminhi3 */

        case 1:
          return 318; /* *p sminsi3 */

        case 2:
          return 319; /* *p smindi3 */

        case 3:
          return 401; /* *p sminsf3 */

        case 4:
          return 402; /* *p smindf3 */

        default:
          return -1;
        }

    case UMIN:
      switch (pattern21 (x1))
        {
        case 0:
          return 320; /* *p uminhi3 */

        case 1:
          return 321; /* *p uminsi3 */

        case 2:
          return 322; /* *p umindi3 */

        default:
          return -1;
        }

    case SMAX:
      switch (pattern20 (x1))
        {
        case 0:
          return 323; /* *p smaxhi3 */

        case 1:
          return 324; /* *p smaxsi3 */

        case 2:
          return 325; /* *p smaxdi3 */

        case 3:
          return 403; /* *p smaxsf3 */

        case 4:
          return 404; /* *p smaxdf3 */

        default:
          return -1;
        }

    case UMAX:
      switch (pattern21 (x1))
        {
        case 0:
          return 326; /* *p umaxhi3 */

        case 1:
          return 327; /* *p umaxsi3 */

        case 2:
          return 328; /* *p umaxdi3 */

        default:
          return -1;
        }

    case ABS:
      switch (pattern22 (x1))
        {
        case 0:
          return 329; /* *p abshi2 */

        case 1:
          return 330; /* *p abssi2 */

        case 2:
          return 331; /* *p absdi2 */

        case 3:
          return 405; /* *p abssf2 */

        case 4:
          return 406; /* *p absdf2 */

        default:
          return -1;
        }

    case NEG:
      switch (pattern22 (x1))
        {
        case 0:
          return 332; /* *p neghi2 */

        case 1:
          return 333; /* *p negsi2 */

        case 2:
          return 334; /* *p negdi2 */

        case 3:
          return 407; /* *p negsf2 */

        case 4:
          return 408; /* *p negdf2 */

        default:
          return -1;
        }

    case NOT:
      x5 = XEXP (x1, 0);
      operands[2] = x5;
      x6 = XEXP (x5, 0);
      operands[3] = x6;
      x7 = XEXP (x5, 1);
      operands[4] = x7;
      x4 = XEXP (x2, 0);
      operands[0] = x4;
      x8 = XEXP (x3, 0);
      operands[1] = x8;
      switch (GET_MODE (operands[0]))
        {
        case HImode:
          if (!nvptx_register_operand (operands[0], HImode)
              || GET_MODE (x3) != HImode
              || !nvptx_register_operand (operands[1], HImode))
            return -1;
          return 335; /* *p one_cmplhi2 */

        case SImode:
          if (!nvptx_register_operand (operands[0], SImode)
              || GET_MODE (x3) != SImode
              || !nvptx_register_operand (operands[1], SImode))
            return -1;
          return 336; /* *p one_cmplsi2 */

        case DImode:
          if (!nvptx_register_operand (operands[0], DImode)
              || GET_MODE (x3) != DImode
              || !nvptx_register_operand (operands[1], DImode))
            return -1;
          return 337; /* *p one_cmpldi2 */

        default:
          return -1;
        }

    case CLZ:
      if (GET_MODE (x3) != SImode)
        return -1;
      x5 = XEXP (x1, 0);
      operands[2] = x5;
      x6 = XEXP (x5, 0);
      operands[3] = x6;
      x7 = XEXP (x5, 1);
      operands[4] = x7;
      x4 = XEXP (x2, 0);
      operands[0] = x4;
      if (!nvptx_register_operand (operands[0], SImode))
        return -1;
      x8 = XEXP (x3, 0);
      operands[1] = x8;
      switch (GET_MODE (operands[1]))
        {
        case SImode:
          if (!nvptx_register_operand (operands[1], SImode))
            return -1;
          return 340; /* *p clzsi2 */

        case DImode:
          if (!nvptx_register_operand (operands[1], DImode))
            return -1;
          return 341; /* *p clzdi2 */

        default:
          return -1;
        }

    case ASHIFT:
      switch (pattern23 (x1))
        {
        case 0:
          return 342; /* *p ashlsi3 */

        case 1:
          return 343; /* *p ashldi3 */

        default:
          return -1;
        }

    case ASHIFTRT:
      switch (pattern23 (x1))
        {
        case 0:
          return 344; /* *p ashrsi3 */

        case 1:
          return 345; /* *p ashrdi3 */

        default:
          return -1;
        }

    case LSHIFTRT:
      switch (pattern23 (x1))
        {
        case 0:
          return 346; /* *p lshrsi3 */

        case 1:
          return 347; /* *p lshrdi3 */

        default:
          return -1;
        }

    case AND:
      switch (pattern24 (x1))
        {
        case 0:
          return 348; /* *p andbi3 */

        case 1:
          return 349; /* *p andhi3 */

        case 2:
          return 350; /* *p andsi3 */

        case 3:
          return 351; /* *p anddi3 */

        default:
          return -1;
        }

    case IOR:
      switch (pattern24 (x1))
        {
        case 0:
          return 352; /* *p iorbi3 */

        case 1:
          return 353; /* *p iorhi3 */

        case 2:
          return 354; /* *p iorsi3 */

        case 3:
          return 355; /* *p iordi3 */

        default:
          return -1;
        }

    case XOR:
      switch (pattern24 (x1))
        {
        case 0:
          return 356; /* *p xorbi3 */

        case 1:
          return 357; /* *p xorhi3 */

        case 2:
          return 358; /* *p xorsi3 */

        case 3:
          return 359; /* *p xordi3 */

        default:
          return -1;
        }

    case NE:
    case EQ:
    case GE:
    case GT:
    case LE:
    case LT:
    case GEU:
    case GTU:
    case LEU:
    case LTU:
    case UNORDERED:
    case ORDERED:
    case UNEQ:
    case UNGE:
    case UNGT:
    case UNLE:
    case UNLT:
      x4 = XEXP (x2, 0);
      operands[0] = x4;
      switch (GET_CODE (x3))
        {
        case NE:
        case EQ:
        case GE:
        case GT:
        case LE:
        case LT:
        case GEU:
        case GTU:
        case LEU:
        case LTU:
          res = recog_5 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
          break;

        default:
          break;
        }
      switch (GET_CODE (x3))
        {
        case NE:
        case EQ:
        case GE:
        case GT:
        case LE:
        case LT:
        case UNORDERED:
        case ORDERED:
        case UNEQ:
        case UNGE:
        case UNGT:
        case UNLE:
        case UNLT:
          operands[1] = x3;
          x5 = XEXP (x1, 0);
          operands[4] = x5;
          x6 = XEXP (x5, 0);
          operands[5] = x6;
          x7 = XEXP (x5, 1);
          operands[6] = x7;
          x8 = XEXP (x3, 0);
          operands[2] = x8;
          x14 = XEXP (x3, 1);
          operands[3] = x14;
          switch (GET_MODE (operands[0]))
            {
            case BImode:
              switch (pattern47 (BImode))
                {
                case 0:
                  return 363; /* *p *cmpsf */

                case 1:
                  return 364; /* *p *cmpdf */

                default:
                  return -1;
                }

            case SImode:
              switch (pattern47 (SImode))
                {
                case 0:
                  return 380; /* *p setcc_intsf */

                case 1:
                  return 381; /* *p setcc_intdf */

                default:
                  return -1;
                }

            case SFmode:
              switch (pattern47 (SFmode))
                {
                case 0:
                  return 385; /* *p setcc_floatsf */

                case 1:
                  return 386; /* *p setcc_floatdf */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        default:
          return -1;
        }

    case IF_THEN_ELSE:
      x5 = XEXP (x1, 0);
      operands[4] = x5;
      x6 = XEXP (x5, 0);
      operands[5] = x6;
      x7 = XEXP (x5, 1);
      operands[6] = x7;
      x4 = XEXP (x2, 0);
      operands[0] = x4;
      x14 = XEXP (x3, 1);
      operands[2] = x14;
      x15 = XEXP (x3, 2);
      operands[3] = x15;
      x8 = XEXP (x3, 0);
      switch (GET_CODE (x8))
        {
        case NE:
          switch (pattern41 (x3))
            {
            case 0:
              return 367; /* *p sel_truehi */

            case 1:
              return 368; /* *p sel_truesi */

            case 2:
              return 369; /* *p sel_truedi */

            case 3:
              return 370; /* *p sel_truesf */

            case 4:
              return 371; /* *p sel_truedf */

            default:
              return -1;
            }

        case EQ:
          switch (pattern41 (x3))
            {
            case 0:
              return 372; /* *p sel_falsehi */

            case 1:
              return 373; /* *p sel_falsesi */

            case 2:
              return 374; /* *p sel_falsedi */

            case 3:
              return 375; /* *p sel_falsesf */

            case 4:
              return 376; /* *p sel_falsedf */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case FMA:
      x5 = XEXP (x1, 0);
      operands[4] = x5;
      x6 = XEXP (x5, 0);
      operands[5] = x6;
      x7 = XEXP (x5, 1);
      operands[6] = x7;
      x4 = XEXP (x2, 0);
      operands[0] = x4;
      x8 = XEXP (x3, 0);
      operands[1] = x8;
      x14 = XEXP (x3, 1);
      operands[2] = x14;
      x15 = XEXP (x3, 2);
      operands[3] = x15;
      switch (GET_MODE (operands[0]))
        {
        case SFmode:
          if (pattern43 (x3, SFmode) != 0)
            return -1;
          return 395; /* *p fmasf4 */

        case DFmode:
          if (pattern43 (x3, DFmode) != 0)
            return -1;
          return 396; /* *p fmadf4 */

        default:
          return -1;
        }

    case SQRT:
      x5 = XEXP (x1, 0);
      operands[2] = x5;
      x6 = XEXP (x5, 0);
      operands[3] = x6;
      x7 = XEXP (x5, 1);
      operands[4] = x7;
      x4 = XEXP (x2, 0);
      operands[0] = x4;
      x8 = XEXP (x3, 0);
      operands[1] = x8;
      switch (GET_MODE (operands[0]))
        {
        case SFmode:
          if (!nvptx_register_operand (operands[0], SFmode)
              || GET_MODE (x3) != SFmode
              || !nvptx_register_operand (operands[1], SFmode))
            return -1;
          return 409; /* *p sqrtsf2 */

        case DFmode:
          if (!nvptx_register_operand (operands[0], DFmode)
              || GET_MODE (x3) != DFmode
              || !nvptx_register_operand (operands[1], DFmode))
            return -1;
          return 410; /* *p sqrtdf2 */

        default:
          return -1;
        }

    case FLOAT_EXTEND:
      if (GET_MODE (x3) != DFmode)
        return -1;
      x5 = XEXP (x1, 0);
      operands[2] = x5;
      x6 = XEXP (x5, 0);
      operands[3] = x6;
      x7 = XEXP (x5, 1);
      operands[4] = x7;
      x4 = XEXP (x2, 0);
      operands[0] = x4;
      if (!nvptx_register_operand (operands[0], DFmode))
        return -1;
      x8 = XEXP (x3, 0);
      operands[1] = x8;
      if (!nvptx_register_operand (operands[1], SFmode))
        return -1;
      return 415; /* *p extendsfdf2 */

    case FLOAT_TRUNCATE:
      if (GET_MODE (x3) != SFmode)
        return -1;
      x5 = XEXP (x1, 0);
      operands[2] = x5;
      x6 = XEXP (x5, 0);
      operands[3] = x6;
      x7 = XEXP (x5, 1);
      operands[4] = x7;
      x4 = XEXP (x2, 0);
      operands[0] = x4;
      if (!nvptx_register_operand (operands[0], SFmode))
        return -1;
      x8 = XEXP (x3, 0);
      operands[1] = x8;
      if (!nvptx_register_operand (operands[1], DFmode))
        return -1;
      return 416; /* *p truncdfsf2 */

    case UNSIGNED_FLOAT:
      switch (pattern26 (x1))
        {
        case 0:
          return 417; /* *p floatunssisf2 */

        case 1:
          return 421; /* *p floatunsdisf2 */

        case 2:
          return 418; /* *p floatunssidf2 */

        case 3:
          return 422; /* *p floatunsdidf2 */

        default:
          return -1;
        }

    case FLOAT:
      switch (pattern26 (x1))
        {
        case 0:
          return 419; /* *p floatsisf2 */

        case 1:
          return 423; /* *p floatdisf2 */

        case 2:
          return 420; /* *p floatsidf2 */

        case 3:
          return 424; /* *p floatdidf2 */

        default:
          return -1;
        }

    case UNSIGNED_FIX:
      switch (pattern28 (x1))
        {
        case 0:
          return 425; /* *p fixuns_truncsfsi2 */

        case 1:
          return 426; /* *p fixuns_truncdfsi2 */

        case 2:
          return 429; /* *p fixuns_truncsfdi2 */

        case 3:
          return 430; /* *p fixuns_truncdfdi2 */

        default:
          return -1;
        }

    case FIX:
      switch (pattern28 (x1))
        {
        case 0:
          return 427; /* *p fix_truncsfsi2 */

        case 1:
          return 428; /* *p fix_truncdfsi2 */

        case 2:
          return 431; /* *p fix_truncsfdi2 */

        case 3:
          return 432; /* *p fix_truncdfdi2 */

        default:
          return -1;
        }

    case UNSPEC_VOLATILE:
      x4 = XEXP (x2, 0);
      operands[0] = x4;
      switch (XVECLEN (x3, 0))
        {
        case 1:
          if (XINT (x3, 1) != 4
              || GET_MODE (x3) != SImode)
            return -1;
          x5 = XEXP (x1, 0);
          operands[2] = x5;
          x6 = XEXP (x5, 0);
          operands[3] = x6;
          x7 = XEXP (x5, 1);
          operands[4] = x7;
          if (!nvptx_register_operand (operands[0], SImode))
            return -1;
          x9 = XVECEXP (x3, 0, 0);
          operands[1] = x9;
          if (!const_int_operand (operands[1], SImode))
            return -1;
          return 453; /* *p oacc_dim_pos */

        case 2:
          if (XINT (x3, 1) != 10)
            return -1;
          x5 = XEXP (x1, 0);
          operands[3] = x5;
          x6 = XEXP (x5, 0);
          operands[4] = x6;
          x7 = XEXP (x5, 1);
          operands[5] = x7;
          if (!nvptx_register_operand (operands[0], VOIDmode))
            return -1;
          x9 = XVECEXP (x3, 0, 0);
          operands[1] = x9;
          if (!nvptx_nonmemory_operand (operands[1], VOIDmode))
            return -1;
          x10 = XVECEXP (x3, 0, 1);
          operands[2] = x10;
          if (!nvptx_nonmemory_operand (operands[2], VOIDmode))
            return -1;
          return 457; /* *p omp_simt_enter_insn */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

static int
recog_8 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  switch (GET_CODE (x2))
    {
    case CONST_INT:
    case CONST_WIDE_INT:
    case CONST_FIXED:
    case CONST_DOUBLE:
    case CONST_VECTOR:
    case CONST:
    case REG:
    case SUBREG:
    case MEM:
    case LABEL_REF:
    case SYMBOL_REF:
    case HIGH:
      operands[1] = x2;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      switch (GET_MODE (operands[0]))
        {
        case BImode:
          if (nvptx_register_operand (operands[0], BImode)
              && nvptx_nonmemory_operand (operands[1], BImode))
            return 1; /* movbi */
          break;

        case QImode:
          if (nonimmediate_operand (operands[0], QImode)
              && general_operand (operands[1], QImode)
              && 
#line 206 "../../gcc/config/nvptx/nvptx.md"
(!MEM_P (operands[0]) || REG_P (operands[1])))
            return 2; /* *movqi_insn */
          break;

        case HImode:
          if (nonimmediate_operand (operands[0], HImode)
              && general_operand (operands[1], HImode)
              && 
#line 206 "../../gcc/config/nvptx/nvptx.md"
(!MEM_P (operands[0]) || REG_P (operands[1])))
            return 3; /* *movhi_insn */
          break;

        case SImode:
          if (nonimmediate_operand (operands[0], SImode)
              && general_operand (operands[1], SImode)
              && 
#line 206 "../../gcc/config/nvptx/nvptx.md"
(!MEM_P (operands[0]) || REG_P (operands[1])))
            return 4; /* *movsi_insn */
          break;

        case DImode:
          if (nonimmediate_operand (operands[0], DImode)
              && general_operand (operands[1], DImode)
              && 
#line 206 "../../gcc/config/nvptx/nvptx.md"
(!MEM_P (operands[0]) || REG_P (operands[1])))
            return 5; /* *movdi_insn */
          break;

        case SFmode:
          if (nonimmediate_operand (operands[0], SFmode)
              && general_operand (operands[1], SFmode)
              && 
#line 220 "../../gcc/config/nvptx/nvptx.md"
(!MEM_P (operands[0]) || REG_P (operands[1])))
            return 6; /* *movsf_insn */
          break;

        case DFmode:
          if (nonimmediate_operand (operands[0], DFmode)
              && general_operand (operands[1], DFmode)
              && 
#line 220 "../../gcc/config/nvptx/nvptx.md"
(!MEM_P (operands[0]) || REG_P (operands[1])))
            return 7; /* *movdf_insn */
          break;

        default:
          break;
        }
      if (GET_CODE (x2) != LABEL_REF
          || GET_CODE (x3) != PC)
        return -1;
      x4 = XEXP (x2, 0);
      operands[0] = x4;
      return 103; /* jump */

    case UNSPEC:
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      switch (XVECLEN (x2, 0))
        {
        case 1:
          switch (XINT (x2, 1))
            {
            case 0:
              x5 = XVECEXP (x2, 0, 0);
              operands[1] = x5;
              if (!const_int_operand (operands[1], VOIDmode))
                return -1;
              switch (GET_MODE (operands[0]))
                {
                case QImode:
                  if (!nvptx_register_operand (operands[0], QImode)
                      || GET_MODE (x2) != QImode)
                    return -1;
                  return 8; /* load_arg_regqi */

                case HImode:
                  if (!nvptx_register_operand (operands[0], HImode)
                      || GET_MODE (x2) != HImode)
                    return -1;
                  return 9; /* load_arg_reghi */

                case SImode:
                  if (!nvptx_register_operand (operands[0], SImode)
                      || GET_MODE (x2) != SImode)
                    return -1;
                  return 10; /* load_arg_regsi */

                case DImode:
                  if (!nvptx_register_operand (operands[0], DImode)
                      || GET_MODE (x2) != DImode)
                    return -1;
                  return 11; /* load_arg_regdi */

                case SFmode:
                  if (!nvptx_register_operand (operands[0], SFmode)
                      || GET_MODE (x2) != SFmode)
                    return -1;
                  return 12; /* load_arg_regsf */

                case DFmode:
                  if (!nvptx_register_operand (operands[0], DFmode)
                      || GET_MODE (x2) != DFmode)
                    return -1;
                  return 13; /* load_arg_regdf */

                default:
                  return -1;
                }

            case 10:
              x5 = XVECEXP (x2, 0, 0);
              operands[1] = x5;
              switch (GET_MODE (operands[0]))
                {
                case SImode:
                  if (!nvptx_register_operand (operands[0], SImode)
                      || GET_MODE (x2) != SImode
                      || !nvptx_register_operand (operands[1], SImode))
                    return -1;
                  return 76; /* bitrevsi2 */

                case DImode:
                  if (!nvptx_register_operand (operands[0], DImode)
                      || GET_MODE (x2) != DImode
                      || !nvptx_register_operand (operands[1], DImode))
                    return -1;
                  return 77; /* bitrevdi2 */

                default:
                  return -1;
                }

            case 4:
              if (GET_MODE (x2) != SFmode
                  || !nvptx_register_operand (operands[0], SFmode))
                return -1;
              x5 = XVECEXP (x2, 0, 0);
              operands[1] = x5;
              if (!nvptx_register_operand (operands[1], SFmode)
                  || !
#line 841 "../../gcc/config/nvptx/nvptx.md"
(flag_unsafe_math_optimizations))
                return -1;
              return 153; /* sinsf2 */

            case 5:
              if (GET_MODE (x2) != SFmode
                  || !nvptx_register_operand (operands[0], SFmode))
                return -1;
              x5 = XVECEXP (x2, 0, 0);
              operands[1] = x5;
              if (!nvptx_register_operand (operands[1], SFmode)
                  || !
#line 848 "../../gcc/config/nvptx/nvptx.md"
(flag_unsafe_math_optimizations))
                return -1;
              return 154; /* cossf2 */

            case 2:
              if (GET_MODE (x2) != SFmode
                  || !nvptx_register_operand (operands[0], SFmode))
                return -1;
              x5 = XVECEXP (x2, 0, 0);
              operands[1] = x5;
              if (!nvptx_register_operand (operands[1], SFmode)
                  || !
#line 855 "../../gcc/config/nvptx/nvptx.md"
(flag_unsafe_math_optimizations))
                return -1;
              return 155; /* log2sf2 */

            case 3:
              if (GET_MODE (x2) != SFmode
                  || !nvptx_register_operand (operands[0], SFmode))
                return -1;
              x5 = XVECEXP (x2, 0, 0);
              operands[1] = x5;
              if (!nvptx_register_operand (operands[1], SFmode)
                  || !
#line 862 "../../gcc/config/nvptx/nvptx.md"
(flag_unsafe_math_optimizations))
                return -1;
              return 156; /* exp2sf2 */

            case 6:
              switch (pattern13 (x2))
                {
                case 0:
                  return 175; /* floorsf2 */

                case 1:
                  return 179; /* floordf2 */

                case 2:
                  return 183; /* lfloorsfsi2 */

                case 3:
                  return 185; /* lfloordfsi2 */

                case 4:
                  return 187; /* lfloorsfdi2 */

                case 5:
                  return 189; /* lfloordfdi2 */

                default:
                  return -1;
                }

            case 7:
              switch (pattern14 (x2))
                {
                case 0:
                  return 176; /* btruncsf2 */

                case 1:
                  return 180; /* btruncdf2 */

                default:
                  return -1;
                }

            case 8:
              switch (pattern13 (x2))
                {
                case 0:
                  return 177; /* ceilsf2 */

                case 1:
                  return 181; /* ceildf2 */

                case 2:
                  return 184; /* lceilsfsi2 */

                case 3:
                  return 186; /* lceildfsi2 */

                case 4:
                  return 188; /* lceilsfdi2 */

                case 5:
                  return 190; /* lceildfdi2 */

                default:
                  return -1;
                }

            case 9:
              switch (pattern14 (x2))
                {
                case 0:
                  return 178; /* nearbyintsf2 */

                case 1:
                  return 182; /* nearbyintdf2 */

                default:
                  return -1;
                }

            case 13:
              if (GET_MODE (x2) != SImode
                  || !nvptx_register_operand (operands[0], SImode))
                return -1;
              x5 = XVECEXP (x2, 0, 0);
              operands[1] = x5;
              if (!const_int_operand (operands[1], SImode))
                return -1;
              return 197; /* oacc_dim_size */

            case 15:
              if (GET_MODE (x2) != SImode
                  || !nvptx_register_operand (operands[0], SImode))
                return -1;
              x5 = XVECEXP (x2, 0, 0);
              operands[1] = x5;
              if (!nvptx_register_operand (operands[1], BImode))
                return -1;
              return 205; /* nvptx_vote_ballot */

            case 16:
              if (GET_MODE (x2) != SImode)
                return -1;
              x5 = XVECEXP (x2, 0, 0);
              if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + 0]
                  || !nvptx_register_operand (operands[0], SImode))
                return -1;
              return 208; /* omp_simt_lane */

            default:
              return -1;
            }

        case 2:
          x5 = XVECEXP (x2, 0, 0);
          operands[1] = x5;
          x6 = XVECEXP (x2, 0, 1);
          operands[2] = x6;
          switch (XINT (x2, 1))
            {
            case 1:
              switch (GET_MODE (operands[0]))
                {
                case SFmode:
                  if (pattern30 (x2, SFmode) != 0)
                    return -1;
                  return 141; /* copysignsf3 */

                case DFmode:
                  if (pattern30 (x2, DFmode) != 0)
                    return -1;
                  return 142; /* copysigndf3 */

                default:
                  return -1;
                }

            case 14:
              if (!nvptx_register_operand (operands[1], SImode)
                  || !nvptx_register_operand (operands[2], SImode))
                return -1;
              switch (GET_MODE (operands[0]))
                {
                case DImode:
                  if (!nvptx_register_operand (operands[0], DImode)
                      || GET_MODE (x2) != DImode)
                    return -1;
                  return 211; /* packsidi2 */

                case DFmode:
                  if (!nvptx_register_operand (operands[0], DFmode)
                      || GET_MODE (x2) != DFmode)
                    return -1;
                  return 212; /* packsidf2 */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        case 3:
          if (XINT (x2, 1) != 17)
            return -1;
          x5 = XVECEXP (x2, 0, 0);
          operands[1] = x5;
          x6 = XVECEXP (x2, 0, 1);
          operands[2] = x6;
          if (!nvptx_nonmemory_operand (operands[2], SImode))
            return -1;
          x7 = XVECEXP (x2, 0, 2);
          operands[3] = x7;
          if (!const_int_operand (operands[3], SImode))
            return -1;
          switch (GET_MODE (operands[0]))
            {
            case SImode:
              if (!nvptx_register_operand (operands[0], SImode)
                  || GET_MODE (x2) != SImode
                  || !nvptx_register_operand (operands[1], SImode))
                return -1;
              return 203; /* nvptx_shufflesi */

            case SFmode:
              if (!nvptx_register_operand (operands[0], SFmode)
                  || GET_MODE (x2) != SFmode
                  || !nvptx_register_operand (operands[1], SFmode))
                return -1;
              return 204; /* nvptx_shufflesf */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case ZERO_EXTEND:
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      x4 = XEXP (x2, 0);
      operands[1] = x4;
      switch (GET_MODE (operands[0]))
        {
        case HImode:
          if (!nvptx_register_operand (operands[0], HImode)
              || GET_MODE (x2) != HImode
              || !nvptx_nonimmediate_operand (operands[1], QImode))
            return -1;
          return 14; /* zero_extendqihi2 */

        case SImode:
          switch (pattern15 (x2))
            {
            case 0:
              return 15; /* zero_extendqisi2 */

            case 1:
              return 16; /* zero_extendhisi2 */

            default:
              return -1;
            }

        case DImode:
          switch (pattern16 (x2))
            {
            case 0:
              return 17; /* zero_extendqidi2 */

            case 1:
              return 18; /* zero_extendhidi2 */

            case 2:
              return 19; /* zero_extendsidi2 */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case SIGN_EXTEND:
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      x4 = XEXP (x2, 0);
      operands[1] = x4;
      switch (GET_MODE (operands[0]))
        {
        case SImode:
          switch (pattern15 (x2))
            {
            case 0:
              return 20; /* extendqisi2 */

            case 1:
              return 21; /* extendhisi2 */

            default:
              return -1;
            }

        case DImode:
          switch (pattern16 (x2))
            {
            case 0:
              return 22; /* extendqidi2 */

            case 1:
              return 23; /* extendhidi2 */

            case 2:
              return 24; /* extendsidi2 */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case TRUNCATE:
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      x4 = XEXP (x2, 0);
      operands[1] = x4;
      switch (GET_MODE (operands[0]))
        {
        case QImode:
          if (!nvptx_nonimmediate_operand (operands[0], QImode)
              || GET_MODE (x2) != QImode)
            return -1;
          switch (GET_MODE (operands[1]))
            {
            case HImode:
              if (!nvptx_register_operand (operands[1], HImode))
                return -1;
              return 25; /* trunchiqi2 */

            case SImode:
              if (!nvptx_register_operand (operands[1], SImode))
                return -1;
              return 26; /* truncsiqi2 */

            case DImode:
              if (!nvptx_register_operand (operands[1], DImode))
                return -1;
              return 28; /* truncdiqi2 */

            default:
              return -1;
            }

        case HImode:
          if (!nvptx_nonimmediate_operand (operands[0], HImode))
            return -1;
          switch (pattern5 (x2, HImode))
            {
            case 0:
              return 27; /* truncsihi2 */

            case 1:
              return 29; /* truncdihi2 */

            default:
              return -1;
            }

        case SImode:
          if (!nvptx_nonimmediate_operand (operands[0], SImode)
              || GET_MODE (x2) != SImode
              || !nvptx_register_operand (operands[1], DImode))
            return -1;
          return 30; /* truncdisi2 */

        default:
          return -1;
        }

    case PLUS:
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      x4 = XEXP (x2, 0);
      switch (GET_CODE (x4))
        {
        case REG:
          switch (pattern9 (x2))
            {
            case 0:
              return 31; /* addhi3 */

            case 1:
              return 32; /* addsi3 */

            case 2:
              return 33; /* adddi3 */

            case 3:
              return 131; /* addsf3 */

            case 4:
              return 132; /* adddf3 */

            default:
              return -1;
            }

        case MULT:
          x8 = XEXP (x4, 0);
          operands[1] = x8;
          x9 = XEXP (x4, 1);
          operands[2] = x9;
          x10 = XEXP (x2, 1);
          operands[3] = x10;
          switch (GET_MODE (operands[0]))
            {
            case HImode:
              if (pattern31 (x2, HImode) != 0)
                return -1;
              return 40; /* *madhi3 */

            case SImode:
              if (pattern31 (x2, SImode) != 0)
                return -1;
              return 41; /* *madsi3 */

            case DImode:
              if (pattern31 (x2, DImode) != 0)
                return -1;
              return 42; /* *maddi3 */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case MINUS:
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      x4 = XEXP (x2, 0);
      operands[1] = x4;
      x10 = XEXP (x2, 1);
      operands[2] = x10;
      switch (GET_MODE (operands[0]))
        {
        case HImode:
          if (pattern17 (x2, HImode) != 0)
            return -1;
          return 34; /* subhi3 */

        case SImode:
          if (pattern17 (x2, SImode) != 0)
            return -1;
          return 35; /* subsi3 */

        case DImode:
          if (pattern17 (x2, DImode) != 0)
            return -1;
          return 36; /* subdi3 */

        case SFmode:
          if (pattern17 (x2, SFmode) != 0)
            return -1;
          return 133; /* subsf3 */

        case DFmode:
          if (pattern17 (x2, DFmode) != 0)
            return -1;
          return 134; /* subdf3 */

        default:
          return -1;
        }

    case MULT:
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      switch (pattern9 (x2))
        {
        case 0:
          return 37; /* mulhi3 */

        case 1:
          return 38; /* mulsi3 */

        case 2:
          return 39; /* muldi3 */

        case 3:
          return 135; /* mulsf3 */

        case 4:
          return 136; /* muldf3 */

        default:
          return -1;
        }

    case DIV:
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      switch (pattern9 (x2))
        {
        case 0:
          return 43; /* divhi3 */

        case 1:
          return 44; /* divsi3 */

        case 2:
          return 45; /* divdi3 */

        case 3:
          return 139; /* divsf3 */

        case 4:
          return 140; /* divdf3 */

        default:
          return -1;
        }

    case UDIV:
      switch (pattern1 (x1))
        {
        case 0:
          return 46; /* udivhi3 */

        case 1:
          return 47; /* udivsi3 */

        case 2:
          return 48; /* udivdi3 */

        default:
          return -1;
        }

    case MOD:
      switch (pattern1 (x1))
        {
        case 0:
          return 49; /* modhi3 */

        case 1:
          return 50; /* modsi3 */

        case 2:
          return 51; /* moddi3 */

        default:
          return -1;
        }

    case UMOD:
      switch (pattern1 (x1))
        {
        case 0:
          return 52; /* umodhi3 */

        case 1:
          return 53; /* umodsi3 */

        case 2:
          return 54; /* umoddi3 */

        default:
          return -1;
        }

    case SMIN:
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      switch (pattern9 (x2))
        {
        case 0:
          return 55; /* sminhi3 */

        case 1:
          return 56; /* sminsi3 */

        case 2:
          return 57; /* smindi3 */

        case 3:
          return 143; /* sminsf3 */

        case 4:
          return 144; /* smindf3 */

        default:
          return -1;
        }

    case UMIN:
      switch (pattern1 (x1))
        {
        case 0:
          return 58; /* uminhi3 */

        case 1:
          return 59; /* uminsi3 */

        case 2:
          return 60; /* umindi3 */

        default:
          return -1;
        }

    case SMAX:
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      switch (pattern9 (x2))
        {
        case 0:
          return 61; /* smaxhi3 */

        case 1:
          return 62; /* smaxsi3 */

        case 2:
          return 63; /* smaxdi3 */

        case 3:
          return 145; /* smaxsf3 */

        case 4:
          return 146; /* smaxdf3 */

        default:
          return -1;
        }

    case UMAX:
      switch (pattern1 (x1))
        {
        case 0:
          return 64; /* umaxhi3 */

        case 1:
          return 65; /* umaxsi3 */

        case 2:
          return 66; /* umaxdi3 */

        default:
          return -1;
        }

    case ABS:
      switch (pattern2 (x1))
        {
        case 0:
          return 67; /* abshi2 */

        case 1:
          return 68; /* abssi2 */

        case 2:
          return 69; /* absdi2 */

        case 3:
          return 147; /* abssf2 */

        case 4:
          return 148; /* absdf2 */

        default:
          return -1;
        }

    case NEG:
      switch (pattern2 (x1))
        {
        case 0:
          return 70; /* neghi2 */

        case 1:
          return 71; /* negsi2 */

        case 2:
          return 72; /* negdi2 */

        case 3:
          return 149; /* negsf2 */

        case 4:
          return 150; /* negdf2 */

        default:
          return -1;
        }

    case NOT:
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      x4 = XEXP (x2, 0);
      operands[1] = x4;
      switch (GET_MODE (operands[0]))
        {
        case HImode:
          if (!nvptx_register_operand (operands[0], HImode)
              || GET_MODE (x2) != HImode
              || !nvptx_register_operand (operands[1], HImode))
            return -1;
          return 73; /* one_cmplhi2 */

        case SImode:
          if (!nvptx_register_operand (operands[0], SImode)
              || GET_MODE (x2) != SImode
              || !nvptx_register_operand (operands[1], SImode))
            return -1;
          return 74; /* one_cmplsi2 */

        case DImode:
          if (!nvptx_register_operand (operands[0], DImode)
              || GET_MODE (x2) != DImode
              || !nvptx_register_operand (operands[1], DImode))
            return -1;
          return 75; /* one_cmpldi2 */

        default:
          return -1;
        }

    case CLZ:
      if (GET_MODE (x2) != SImode)
        return -1;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      if (!nvptx_register_operand (operands[0], SImode))
        return -1;
      x4 = XEXP (x2, 0);
      operands[1] = x4;
      switch (GET_MODE (operands[1]))
        {
        case SImode:
          if (!nvptx_register_operand (operands[1], SImode))
            return -1;
          return 78; /* clzsi2 */

        case DImode:
          if (!nvptx_register_operand (operands[1], DImode))
            return -1;
          return 79; /* clzdi2 */

        default:
          return -1;
        }

    case ASHIFT:
      switch (pattern3 (x1))
        {
        case 0:
          return 80; /* ashlsi3 */

        case 1:
          return 81; /* ashldi3 */

        default:
          return -1;
        }

    case ASHIFTRT:
      switch (pattern3 (x1))
        {
        case 0:
          return 82; /* ashrsi3 */

        case 1:
          return 83; /* ashrdi3 */

        default:
          return -1;
        }

    case LSHIFTRT:
      switch (pattern3 (x1))
        {
        case 0:
          return 84; /* lshrsi3 */

        case 1:
          return 85; /* lshrdi3 */

        default:
          return -1;
        }

    case AND:
      switch (pattern4 (x1))
        {
        case 0:
          return 86; /* andbi3 */

        case 1:
          return 87; /* andhi3 */

        case 2:
          return 88; /* andsi3 */

        case 3:
          return 89; /* anddi3 */

        default:
          return -1;
        }

    case IOR:
      switch (pattern4 (x1))
        {
        case 0:
          return 90; /* iorbi3 */

        case 1:
          return 91; /* iorhi3 */

        case 2:
          return 92; /* iorsi3 */

        case 3:
          return 93; /* iordi3 */

        default:
          return -1;
        }

    case XOR:
      switch (pattern4 (x1))
        {
        case 0:
          return 94; /* xorbi3 */

        case 1:
          return 95; /* xorhi3 */

        case 2:
          return 96; /* xorsi3 */

        case 3:
          return 97; /* xordi3 */

        default:
          return -1;
        }

    case NE:
    case EQ:
    case GE:
    case GT:
    case LE:
    case LT:
    case GEU:
    case GTU:
    case LEU:
    case LTU:
    case UNORDERED:
    case ORDERED:
    case UNEQ:
    case UNGE:
    case UNGT:
    case UNLE:
    case UNLT:
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      switch (GET_CODE (x2))
        {
        case NE:
        case EQ:
        case GE:
        case GT:
        case LE:
        case LT:
        case GEU:
        case GTU:
        case LEU:
        case LTU:
          res = recog_1 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
          break;

        default:
          break;
        }
      switch (GET_CODE (x2))
        {
        case NE:
        case EQ:
        case GE:
        case GT:
        case LE:
        case LT:
        case UNORDERED:
        case ORDERED:
        case UNEQ:
        case UNGE:
        case UNGT:
        case UNLE:
        case UNLT:
          operands[1] = x2;
          x4 = XEXP (x2, 0);
          operands[2] = x4;
          x10 = XEXP (x2, 1);
          operands[3] = x10;
          switch (GET_MODE (operands[0]))
            {
            case BImode:
              switch (pattern33 (BImode))
                {
                case 0:
                  return 101; /* *cmpsf */

                case 1:
                  return 102; /* *cmpdf */

                default:
                  return -1;
                }

            case SImode:
              switch (pattern33 (SImode))
                {
                case 0:
                  return 122; /* setcc_intsf */

                case 1:
                  return 123; /* setcc_intdf */

                default:
                  return -1;
                }

            case SFmode:
              switch (pattern33 (SFmode))
                {
                case 0:
                  return 127; /* setcc_floatsf */

                case 1:
                  return 128; /* setcc_floatdf */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        default:
          return -1;
        }

    case IF_THEN_ELSE:
      x4 = XEXP (x2, 0);
      switch (GET_CODE (x4))
        {
        case NE:
          switch (pattern11 (x1))
            {
            case 0:
              return 104; /* br_true */

            case 1:
              return 109; /* sel_truehi */

            case 2:
              return 110; /* sel_truesi */

            case 3:
              return 111; /* sel_truedi */

            case 4:
              return 112; /* sel_truesf */

            case 5:
              return 113; /* sel_truedf */

            case 6:
              return 106; /* br_true_uni */

            default:
              return -1;
            }

        case EQ:
          switch (pattern11 (x1))
            {
            case 0:
              return 105; /* br_false */

            case 1:
              return 114; /* sel_falsehi */

            case 2:
              return 115; /* sel_falsesi */

            case 3:
              return 116; /* sel_falsedi */

            case 4:
              return 117; /* sel_falsesf */

            case 5:
              return 118; /* sel_falsedf */

            case 6:
              return 107; /* br_false_uni */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case FMA:
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      x4 = XEXP (x2, 0);
      operands[1] = x4;
      x10 = XEXP (x2, 1);
      operands[2] = x10;
      x11 = XEXP (x2, 2);
      operands[3] = x11;
      switch (GET_MODE (operands[0]))
        {
        case SFmode:
          if (pattern29 (x2, SFmode) != 0)
            return -1;
          return 137; /* fmasf4 */

        case DFmode:
          if (pattern29 (x2, DFmode) != 0)
            return -1;
          return 138; /* fmadf4 */

        default:
          return -1;
        }

    case SQRT:
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      x4 = XEXP (x2, 0);
      operands[1] = x4;
      switch (GET_MODE (operands[0]))
        {
        case SFmode:
          if (!nvptx_register_operand (operands[0], SFmode)
              || GET_MODE (x2) != SFmode
              || !nvptx_register_operand (operands[1], SFmode))
            return -1;
          return 151; /* sqrtsf2 */

        case DFmode:
          if (!nvptx_register_operand (operands[0], DFmode)
              || GET_MODE (x2) != DFmode
              || !nvptx_register_operand (operands[1], DFmode))
            return -1;
          return 152; /* sqrtdf2 */

        default:
          return -1;
        }

    case FLOAT_EXTEND:
      if (GET_MODE (x2) != DFmode)
        return -1;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      if (!nvptx_register_operand (operands[0], DFmode))
        return -1;
      x4 = XEXP (x2, 0);
      operands[1] = x4;
      if (!nvptx_register_operand (operands[1], SFmode))
        return -1;
      return 157; /* extendsfdf2 */

    case FLOAT_TRUNCATE:
      if (GET_MODE (x2) != SFmode)
        return -1;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      if (!nvptx_register_operand (operands[0], SFmode))
        return -1;
      x4 = XEXP (x2, 0);
      operands[1] = x4;
      if (!nvptx_register_operand (operands[1], DFmode))
        return -1;
      return 158; /* truncdfsf2 */

    case UNSIGNED_FLOAT:
      switch (pattern6 (x1))
        {
        case 0:
          return 159; /* floatunssisf2 */

        case 1:
          return 163; /* floatunsdisf2 */

        case 2:
          return 160; /* floatunssidf2 */

        case 3:
          return 164; /* floatunsdidf2 */

        default:
          return -1;
        }

    case FLOAT:
      switch (pattern6 (x1))
        {
        case 0:
          return 161; /* floatsisf2 */

        case 1:
          return 165; /* floatdisf2 */

        case 2:
          return 162; /* floatsidf2 */

        case 3:
          return 166; /* floatdidf2 */

        default:
          return -1;
        }

    case UNSIGNED_FIX:
      switch (pattern8 (x1))
        {
        case 0:
          return 167; /* fixuns_truncsfsi2 */

        case 1:
          return 168; /* fixuns_truncdfsi2 */

        case 2:
          return 171; /* fixuns_truncsfdi2 */

        case 3:
          return 172; /* fixuns_truncdfdi2 */

        default:
          return -1;
        }

    case FIX:
      switch (pattern8 (x1))
        {
        case 0:
          return 169; /* fix_truncsfsi2 */

        case 1:
          return 170; /* fix_truncdfsi2 */

        case 2:
          return 173; /* fix_truncsfdi2 */

        case 3:
          return 174; /* fix_truncdfdi2 */

        default:
          return -1;
        }

    case UNSPEC_VOLATILE:
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      switch (XVECLEN (x2, 0))
        {
        case 1:
          if (XINT (x2, 1) != 4
              || GET_MODE (x2) != SImode
              || !nvptx_register_operand (operands[0], SImode))
            return -1;
          x5 = XVECEXP (x2, 0, 0);
          operands[1] = x5;
          if (!const_int_operand (operands[1], SImode))
            return -1;
          return 198; /* oacc_dim_pos */

        case 2:
          if (XINT (x2, 1) != 10
              || !nvptx_register_operand (operands[0], VOIDmode))
            return -1;
          x5 = XVECEXP (x2, 0, 0);
          operands[1] = x5;
          if (!nvptx_nonmemory_operand (operands[1], VOIDmode))
            return -1;
          x6 = XVECEXP (x2, 0, 1);
          operands[2] = x6;
          if (!nvptx_nonmemory_operand (operands[2], VOIDmode))
            return -1;
          return 206; /* omp_simt_enter_insn */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
recog (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18, x19, x20, x21, x22, x23, x24, x25;
  rtx x26, x27, x28, x29, x30, x31, x32, x33;
  rtx x34, x35;
  int res ATTRIBUTE_UNUSED;
  recog_data.insn = NULL;
  switch (GET_CODE (x1))
    {
    case SET:
      return recog_8 (x1, insn, pnum_clobbers);

    case PARALLEL:
      if (XVECLEN (x1, 0) >= 1
          && call_operation (x1, VOIDmode))
        {
          res = recog_2 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
        }
      if (XVECLEN (x1, 0) != 2)
        return -1;
      x2 = XVECEXP (x1, 0, 0);
      if (GET_CODE (x2) != SET)
        return -1;
      x3 = XVECEXP (x1, 0, 1);
      if (GET_CODE (x3) != SET)
        return -1;
      x4 = XEXP (x2, 1);
      switch (GET_CODE (x4))
        {
        case UNSPEC:
          if (XVECLEN (x4, 0) != 2
              || XINT (x4, 1) != 14
              || GET_MODE (x4) != SImode)
            return -1;
          x5 = XVECEXP (x4, 0, 1);
          if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
            return -1;
          x6 = XEXP (x3, 1);
          if (GET_CODE (x6) != UNSPEC
              || XVECLEN (x6, 0) != 2
              || XINT (x6, 1) != 14
              || GET_MODE (x6) != SImode)
            return -1;
          x7 = XVECEXP (x6, 0, 1);
          if (x7 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
            return -1;
          x8 = XEXP (x2, 0);
          operands[0] = x8;
          if (!nvptx_register_operand (operands[0], SImode))
            return -1;
          x9 = XVECEXP (x4, 0, 0);
          operands[2] = x9;
          x10 = XEXP (x3, 0);
          operands[1] = x10;
          if (!nvptx_register_operand (operands[1], SImode))
            return -1;
          x11 = XVECEXP (x6, 0, 0);
          if (!rtx_equal_p (x11, operands[2]))
            return -1;
          switch (GET_MODE (operands[2]))
            {
            case DImode:
              if (!nvptx_register_operand (operands[2], DImode))
                return -1;
              return 209; /* unpackdisi2 */

            case DFmode:
              if (!nvptx_register_operand (operands[2], DFmode))
                return -1;
              return 210; /* unpackdfsi2 */

            default:
              return -1;
            }

        case UNSPEC_VOLATILE:
          switch (XVECLEN (x4, 0))
            {
            case 4:
              if (XINT (x4, 1) != 1)
                return -1;
              x6 = XEXP (x3, 1);
              if (GET_CODE (x6) != UNSPEC_VOLATILE
                  || XVECLEN (x6, 0) != 1
                  || XINT (x6, 1) != 1)
                return -1;
              x11 = XVECEXP (x6, 0, 0);
              if (x11 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
                return -1;
              x8 = XEXP (x2, 0);
              operands[0] = x8;
              x9 = XVECEXP (x4, 0, 0);
              operands[1] = x9;
              x5 = XVECEXP (x4, 0, 1);
              operands[2] = x5;
              x12 = XVECEXP (x4, 0, 2);
              operands[3] = x12;
              x13 = XVECEXP (x4, 0, 3);
              operands[4] = x13;
              if (!const_int_operand (operands[4], SImode))
                return -1;
              x10 = XEXP (x3, 0);
              if (!rtx_equal_p (x10, operands[1]))
                return -1;
              switch (GET_MODE (operands[0]))
                {
                case SImode:
                  if (pattern49 (x1, SImode) != 0)
                    return -1;
                  return 213; /* atomic_compare_and_swapsi_1 */

                case DImode:
                  if (pattern49 (x1, DImode) != 0)
                    return -1;
                  return 214; /* atomic_compare_and_swapdi_1 */

                default:
                  return -1;
                }

            case 2:
              x5 = XVECEXP (x4, 0, 1);
              operands[3] = x5;
              if (!const_int_operand (operands[3], SImode))
                return -1;
              switch (XINT (x4, 1))
                {
                case 2:
                  x8 = XEXP (x2, 0);
                  operands[0] = x8;
                  x9 = XVECEXP (x4, 0, 0);
                  operands[1] = x9;
                  x6 = XEXP (x3, 1);
                  operands[2] = x6;
                  x10 = XEXP (x3, 0);
                  if (!rtx_equal_p (x10, operands[1]))
                    return -1;
                  switch (GET_MODE (operands[0]))
                    {
                    case SImode:
                      if (pattern42 (x4, SImode) != 0)
                        return -1;
                      return 215; /* atomic_exchangesi */

                    case DImode:
                      if (pattern42 (x4, DImode) != 0)
                        return -1;
                      return 216; /* atomic_exchangedi */

                    default:
                      return -1;
                    }

                case 0:
                  x9 = XVECEXP (x4, 0, 0);
                  if (GET_CODE (x9) != PLUS)
                    return -1;
                  x8 = XEXP (x2, 0);
                  operands[1] = x8;
                  x14 = XEXP (x9, 1);
                  operands[2] = x14;
                  x10 = XEXP (x3, 0);
                  operands[0] = x10;
                  x15 = XEXP (x9, 0);
                  if (!rtx_equal_p (x15, operands[1]))
                    return -1;
                  x6 = XEXP (x3, 1);
                  if (!rtx_equal_p (x6, operands[1]))
                    return -1;
                  switch (GET_MODE (operands[1]))
                    {
                    case SImode:
                      if (pattern48 (x4, SImode) != 0)
                        return -1;
                      return 217; /* atomic_fetch_addsi */

                    case DImode:
                      if (pattern48 (x4, DImode) != 0)
                        return -1;
                      return 218; /* atomic_fetch_adddi */

                    case SFmode:
                      if (pattern48 (x4, SFmode) != 0)
                        return -1;
                      return 219; /* atomic_fetch_addsf */

                    default:
                      return -1;
                    }

                default:
                  return -1;
                }

            default:
              return -1;
            }

        default:
          return -1;
        }

    case CONST_INT:
      if (XWINT (x1, 0) != 0L)
        return -1;
      return 191; /* nop */

    case RETURN:
      return 192; /* return */

    case UNSPEC:
      if (XVECLEN (x1, 0) != 1
          || XINT (x1, 1) != 12)
        return -1;
      x2 = XVECEXP (x1, 0, 0);
      operands[0] = x2;
      if (!nvptx_register_operand (operands[0], VOIDmode)
          || !
#line 1027 "../../gcc/config/nvptx/nvptx.md"
(TARGET_SOFT_STACK))
        return -1;
      return 193; /* set_softstack_insn */

    case TRAP_IF:
      x16 = XEXP (x1, 1);
      if (x16 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      x17 = XEXP (x1, 0);
      switch (GET_CODE (x17))
        {
        case CONST_INT:
          if (XWINT (x17, 0) != 1L)
            return -1;
          return 194; /* trap */

        case NE:
          x18 = XEXP (x17, 1);
          if (x18 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
            return -1;
          x19 = XEXP (x17, 0);
          operands[0] = x19;
          if (!nvptx_register_operand (operands[0], BImode))
            return -1;
          return 195; /* trap_if_true */

        case EQ:
          x18 = XEXP (x17, 1);
          if (x18 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
            return -1;
          x19 = XEXP (x17, 0);
          operands[0] = x19;
          if (!nvptx_register_operand (operands[0], BImode))
            return -1;
          return 196; /* trap_if_false */

        default:
          return -1;
        }

    case UNSPEC_VOLATILE:
      if (XVECLEN (x1, 0) != 1)
        return -1;
      switch (XINT (x1, 1))
        {
        case 5:
          if (GET_MODE (x1) != SImode)
            return -1;
          x2 = XVECEXP (x1, 0, 0);
          operands[0] = x2;
          if (!const_int_operand (operands[0], SImode))
            return -1;
          return 199; /* nvptx_fork */

        case 6:
          if (GET_MODE (x1) != SImode)
            return -1;
          x2 = XVECEXP (x1, 0, 0);
          operands[0] = x2;
          if (!const_int_operand (operands[0], SImode))
            return -1;
          return 200; /* nvptx_forked */

        case 7:
          if (GET_MODE (x1) != SImode)
            return -1;
          x2 = XVECEXP (x1, 0, 0);
          operands[0] = x2;
          if (!const_int_operand (operands[0], SImode))
            return -1;
          return 201; /* nvptx_joining */

        case 8:
          if (GET_MODE (x1) != SImode)
            return -1;
          x2 = XVECEXP (x1, 0, 0);
          operands[0] = x2;
          if (!const_int_operand (operands[0], SImode))
            return -1;
          return 202; /* nvptx_join */

        case 11:
          x2 = XVECEXP (x1, 0, 0);
          operands[0] = x2;
          if (!nvptx_register_operand (operands[0], VOIDmode))
            return -1;
          return 207; /* omp_simt_exit */

        case 3:
          x2 = XVECEXP (x1, 0, 0);
          operands[0] = x2;
          if (!const_int_operand (operands[0], SImode))
            return -1;
          return 220; /* nvptx_barsync */

        case 9:
          x2 = XVECEXP (x1, 0, 0);
          if (x2 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
            return -1;
          return 221; /* nvptx_nounroll */

        default:
          return -1;
        }

    case COND_EXEC:
      x17 = XEXP (x1, 0);
      if (!predicate_operator (x17, VOIDmode))
        return -1;
      x19 = XEXP (x17, 0);
      if (!nvptx_register_operand (x19, BImode))
        return -1;
      x18 = XEXP (x17, 1);
      if (!const0_operand (x18, BImode))
        return -1;
      x16 = XEXP (x1, 1);
      switch (GET_CODE (x16))
        {
        case SET:
          return recog_7 (x1, insn, pnum_clobbers);

        case PARALLEL:
          if (XVECLEN (x16, 0) >= 1
              && call_operation (x16, VOIDmode))
            {
              res = recog_6 (x1, insn, pnum_clobbers);
              if (res >= 0)
                return res;
            }
          if (XVECLEN (x16, 0) != 2)
            return -1;
          x20 = XVECEXP (x16, 0, 0);
          if (GET_CODE (x20) != SET)
            return -1;
          x21 = XVECEXP (x16, 0, 1);
          if (GET_CODE (x21) != SET)
            return -1;
          x22 = XEXP (x20, 1);
          switch (GET_CODE (x22))
            {
            case UNSPEC:
              if (XVECLEN (x22, 0) != 2
                  || XINT (x22, 1) != 14
                  || GET_MODE (x22) != SImode)
                return -1;
              x23 = XVECEXP (x22, 0, 1);
              if (x23 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
                return -1;
              x24 = XEXP (x21, 1);
              if (GET_CODE (x24) != UNSPEC
                  || XVECLEN (x24, 0) != 2
                  || XINT (x24, 1) != 14
                  || GET_MODE (x24) != SImode)
                return -1;
              x25 = XVECEXP (x24, 0, 1);
              if (x25 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
                return -1;
              operands[3] = x17;
              operands[4] = x19;
              operands[5] = x18;
              x26 = XEXP (x20, 0);
              operands[0] = x26;
              if (!nvptx_register_operand (operands[0], SImode))
                return -1;
              x27 = XVECEXP (x22, 0, 0);
              operands[2] = x27;
              x28 = XEXP (x21, 0);
              operands[1] = x28;
              if (!nvptx_register_operand (operands[1], SImode))
                return -1;
              x29 = XVECEXP (x24, 0, 0);
              if (!rtx_equal_p (x29, operands[2]))
                return -1;
              switch (GET_MODE (operands[2]))
                {
                case DImode:
                  if (!nvptx_register_operand (operands[2], DImode))
                    return -1;
                  return 460; /* *p unpackdisi2 */

                case DFmode:
                  if (!nvptx_register_operand (operands[2], DFmode))
                    return -1;
                  return 461; /* *p unpackdfsi2 */

                default:
                  return -1;
                }

            case UNSPEC_VOLATILE:
              switch (XVECLEN (x22, 0))
                {
                case 4:
                  if (XINT (x22, 1) != 1)
                    return -1;
                  x24 = XEXP (x21, 1);
                  if (GET_CODE (x24) != UNSPEC_VOLATILE
                      || XVECLEN (x24, 0) != 1
                      || XINT (x24, 1) != 1)
                    return -1;
                  x29 = XVECEXP (x24, 0, 0);
                  if (x29 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
                    return -1;
                  operands[5] = x17;
                  operands[6] = x19;
                  operands[7] = x18;
                  x26 = XEXP (x20, 0);
                  operands[0] = x26;
                  x27 = XVECEXP (x22, 0, 0);
                  operands[1] = x27;
                  x23 = XVECEXP (x22, 0, 1);
                  operands[2] = x23;
                  x30 = XVECEXP (x22, 0, 2);
                  operands[3] = x30;
                  x31 = XVECEXP (x22, 0, 3);
                  operands[4] = x31;
                  if (!const_int_operand (operands[4], SImode))
                    return -1;
                  x28 = XEXP (x21, 0);
                  if (!rtx_equal_p (x28, operands[1]))
                    return -1;
                  switch (GET_MODE (operands[0]))
                    {
                    case SImode:
                      if (pattern52 (x16, SImode) != 0)
                        return -1;
                      return 464; /* *p atomic_compare_and_swapsi_1 */

                    case DImode:
                      if (pattern52 (x16, DImode) != 0)
                        return -1;
                      return 465; /* *p atomic_compare_and_swapdi_1 */

                    default:
                      return -1;
                    }

                case 2:
                  operands[4] = x17;
                  operands[5] = x19;
                  operands[6] = x18;
                  x23 = XVECEXP (x22, 0, 1);
                  operands[3] = x23;
                  if (!const_int_operand (operands[3], SImode))
                    return -1;
                  switch (XINT (x22, 1))
                    {
                    case 2:
                      x26 = XEXP (x20, 0);
                      operands[0] = x26;
                      x27 = XVECEXP (x22, 0, 0);
                      operands[1] = x27;
                      x24 = XEXP (x21, 1);
                      operands[2] = x24;
                      x28 = XEXP (x21, 0);
                      if (!rtx_equal_p (x28, operands[1]))
                        return -1;
                      switch (GET_MODE (operands[0]))
                        {
                        case SImode:
                          if (pattern50 (x22, SImode) != 0)
                            return -1;
                          return 466; /* *p atomic_exchangesi */

                        case DImode:
                          if (pattern50 (x22, DImode) != 0)
                            return -1;
                          return 467; /* *p atomic_exchangedi */

                        default:
                          return -1;
                        }

                    case 0:
                      x27 = XVECEXP (x22, 0, 0);
                      if (GET_CODE (x27) != PLUS)
                        return -1;
                      x26 = XEXP (x20, 0);
                      operands[1] = x26;
                      x32 = XEXP (x27, 1);
                      operands[2] = x32;
                      x28 = XEXP (x21, 0);
                      operands[0] = x28;
                      x33 = XEXP (x27, 0);
                      if (!rtx_equal_p (x33, operands[1]))
                        return -1;
                      x24 = XEXP (x21, 1);
                      if (!rtx_equal_p (x24, operands[1]))
                        return -1;
                      switch (GET_MODE (operands[1]))
                        {
                        case SImode:
                          if (pattern51 (x22, SImode) != 0)
                            return -1;
                          return 468; /* *p atomic_fetch_addsi */

                        case DImode:
                          if (pattern51 (x22, DImode) != 0)
                            return -1;
                          return 469; /* *p atomic_fetch_adddi */

                        case SFmode:
                          if (pattern51 (x22, SFmode) != 0)
                            return -1;
                          return 470; /* *p atomic_fetch_addsf */

                        default:
                          return -1;
                        }

                    default:
                      return -1;
                    }

                default:
                  return -1;
                }

            default:
              return -1;
            }

        case CONST_INT:
          if (XWINT (x16, 0) != 0L)
            return -1;
          operands[0] = x17;
          operands[1] = x19;
          operands[2] = x18;
          return 449; /* *p nop */

        case UNSPEC:
          if (XVECLEN (x16, 0) != 1
              || XINT (x16, 1) != 12)
            return -1;
          operands[1] = x17;
          operands[2] = x19;
          operands[3] = x18;
          x20 = XVECEXP (x16, 0, 0);
          operands[0] = x20;
          if (!nvptx_register_operand (operands[0], VOIDmode)
              || !
#line 1027 "../../gcc/config/nvptx/nvptx.md"
(TARGET_SOFT_STACK))
            return -1;
          return 450; /* *p set_softstack_insn */

        case TRAP_IF:
          x34 = XEXP (x16, 0);
          if (x34 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
            return -1;
          x35 = XEXP (x16, 1);
          if (x35 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
            return -1;
          operands[0] = x17;
          operands[1] = x19;
          operands[2] = x18;
          return 451; /* *p trap */

        case UNSPEC_VOLATILE:
          if (XVECLEN (x16, 0) != 1
              || XINT (x16, 1) != 11)
            return -1;
          operands[1] = x17;
          operands[2] = x19;
          operands[3] = x18;
          x20 = XVECEXP (x16, 0, 0);
          operands[0] = x20;
          if (!nvptx_register_operand (operands[0], VOIDmode))
            return -1;
          return 458; /* *p omp_simt_exit */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

rtx_insn *
split_insns (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx_insn *res ATTRIBUTE_UNUSED;
  recog_data.insn = NULL;
  return NULL;
}

rtx_insn *
peephole2_insns (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pmatch_len_ ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx_insn *res ATTRIBUTE_UNUSED;
  recog_data.insn = NULL;
  return NULL;
}
